{$A+,B-,F+,G+,N+,P+,Q-,R-,T-,V+,X+}
unit bmpcxlib;
{****************************************************************************
 * Author           : Stefan Goehler, Germany                               *
 * Version          : unofficial 1.2a                                       *
 *******                                                                    *
 * my mail-adress   : stefan.goehler@gmx.de                                 *
 * my homepage      : http://sourcenet.home.pages.de                        *
 ****** COPYRIGHT ***********************************************************
 * This unit is delivered with the GrafX-package. You are not allowed to    *
 * use this unit or parts of it out of the GrafX-package, i.e. for another  *
 * graphical unit. For more copyright information see grafx2.txt            *
 ****** HISTORY *************************************************************
 * Version 1.0  .first conversion from old bmpcx of GrafX 1.4b2             *
 *         1.1  +PCX loader and saver now 24 bit capable                    *
 *              *fixed old PCX loader/saver bugs                            *
 *         1.2  +BMP loader OS/2 BMP capable                                *
 ****************************************************************************}
interface
uses grafx2,gx_glob,gx_image,gx_col,newfrontier,stream32;

  function loadpcx(var stream : tstream32;var image : timage;usebpp,flags : longint) : word;
  function loadbmp(var stream : tstream32;var image : timage;usebpp,flags : longint) : word;
  function savebmp(var stream : tstream32;var image : timage) : word;
  function savepcx(var stream : tstream32;var image : timage) : word;
  function info_bmp(var stream : tstream32;var image_info : timageinfo) : word;
  function info_pcx(var stream : tstream32;var image_info : timageinfo) : word;

implementation
var
  p           : pointer;
  nr,maxread  : word;
  i           : word;
  s           : pstream32;

type
  pcxh = record
    id,version              : byte;
    compression             : byte; { 1= RLE }
    bpp                     : byte;
    minx,miny,
    maxx,maxy,
    dpix,dpiy               : word;
    pal16                   : array[0..47] of byte;
    reserved,nplanes        : byte;
    bytesperline,
    paltype                 : word; { 1=b/w or colored; 2= greyscale }
    hscreensize,vscreensize : word; { mostly filled with garbage     }
    reserved2               : array[0..53] of byte;
  end;

procedure readblock;
begin
  nr := s^.read32(farptr(p),maxread);
end;

procedure refill(frompos : word);
begin
  move(ptr(seg(p^),ofs(p^)+frompos)^,p^,maxread-frompos);
  nr := s^.read32(ptr48(seg(p^),ofs(p^)+maxread-frompos),frompos);
end;


function loadpcx(var stream : tstream32;var image : timage;usebpp,flags : longint) : word;
var
  i,y,mempos  : word;
  h           : pcxh;
  linep       : pointer;
  sizex,sizey : word;
  stoppos     : word;
  pal         : pointer;
  imgpos      : longint;
  plane       : word;
  b           : byte;
  convertdata : tcnvproc;
  cnvtmp      : pcnvproc;
  count       : longint;

begin
  loadpcx := errfileerror;
  if (stream.status <> stok) then exit;
  s := @stream;
  count := stream.read32(farptr(@h),sizeof(h));
  h.bpp := h.bpp*h.nplanes;
  if (h.id <> $0A)or(h.version <> 5)or((h.bpp <> 8)and(h.bpp <> 24))or(h.compression <> 1) then begin
    loadpcx := errfalseformat;
    stream.done;
    exit;
  end;
  if count < sizeof(h) then begin
    loadpcx := errfalseend;
    stream.done;
    exit;
  end;


  sizex := h.maxx-h.minx;
  sizey := h.maxy-h.miny;
  cnvtmp  := prepareimage_cnv(image,sizex+1,sizey+1,h.bpp,usebpp,0,flags,cnvimgmd);
  if (cnvtmp = nil) then begin
    loadpcx := errfalsebpp;
    stream.done;
    exit;
  end;
  convertdata := tcnvproc(cnvtmp);
  if h.bpp <= 8 then begin
    stream.seek(stream.getsize-769);
    stream.read32(farptr(@b),1);
    if b = 12 then begin
      getmem(pal,768);
      stream.read32(farptr(pal),768);
      pal_24to32(farptr(@pal^),cnvpal,256);
      case image.bpp of
        15 : pal_32to15(cnvpal,cnvpal,(word(1) shl h.bpp));
        16 : pal_32to16(cnvpal,cnvpal,(word(1) shl h.bpp));
      end;
      freemem(pal,768);
    end;
    stream.seek(sizeof(h));
  end;

  getmem(linep,sizex*3+4);
  maxread := 64000;
  getmem(p,succ(maxread));
  mempos  := ofs(p^);
  stoppos := mempos+maxread-1;
  readblock;
  imgpos  := image.imagestart;
  if h.bpp = 8 then begin
  for y := 0 to sizey do begin
    asm
           db    66h;xor ax,ax
           db    66h;xor bx,bx
           db    66h;xor cx,cx
           mov   ax,nr
           or    ax,ax
           jz    @start
           mov   bx,mempos
           sub   bx,p.word
           mov   cx,sizex
           db    66h;shl cx,1
           db    66h;add cx,bx
           db    66h;cmp cx,ax
           jna   @start
           push  bx
           call  refill
           mov   ax,p.word
           mov   mempos,ax

@start   : mov   si,mempos
           les   di,linep
           mov   dx,sizex
           push  ds
           mov   ds,p[2].word
@lp      : mov   bx,ds:[si]
           cmp   bl,0BFh
           jna   @putpixel
           mov   al,bh
           and   bx,3Fh
           mov   ah,al
           mov   cx,bx
           shr   cx,2
           jz    @below4
           push  ax
           db    66h;shl ax,16
           pop   ax
           db    0F3h,66h,0ABh      { rep stosd }
@below4  : mov   cx,bx
           and   cx,11b
           jz    @zero
           mov   es:[di],ax
           add   di,cx
           and   cl,1b
           jz    @zero
           mov   es:[di-1],al
@zero    : add   si,2
           sub   dx,bx
           jnc   @lp
           jmp   @stop
@putpixel: mov   es:[di],bl
           inc   si
           inc   di
           sub   dx,1
           jnc   @lp
@stop    : mov   mempos,si
           pop   ds
    end;
    convertdata(farptr(linep),ptr48(image.data,imgpos),sizex+1);
    inc(imgpos,image.bpl);
  end;
  end else if h.bpp = 24 then
    for y := 0 to sizey do begin
    for plane := 2 downto 0 do
    asm
           db    66h;xor ax,ax
           db    66h;xor bx,bx
           db    66h;xor cx,cx
           mov   ax,nr
           or    ax,ax
           jz    @start
           mov   bx,mempos
           sub   bx,p.word
           mov   cx,h.bytesperline
           db    66h;shl cx,2
           db    66h;add cx,bx
           db    66h;cmp cx,ax
           jna   @start
           push  bx
           call  refill
           mov   ax,p.word
           mov   mempos,ax

@start   : mov   si,mempos
           les   di,linep
           add   di,plane
           mov   dx,sizex
           push  ds
           mov   ds,p[2].word
@lp      : mov   bx,ds:[si]
           cmp   bl,0BFh
           jna   @putpixel
           mov   al,bh
           and   bx,3Fh
           jz    @zero
           mov   cx,bx
@lpfill  :
           mov   es:[di],al
           add   di,3
           dec   cx
           jnz   @lpfill

@zero    : add   si,2
           sub   dx,bx
           jnc   @lp
           jmp   @stop
@putpixel: mov   es:[di],bl
           inc   si
           add   di,3
           sub   dx,1
           jnc   @lp
@stop    : mov   mempos,si
           pop   ds
    end;
    cnvypos := y;
    convertdata(farptr(linep),ptr48(image.data,imgpos),sizex*3+3);
    inc(imgpos,image.bpl);
  end;
  stream.done;
  freemem(p,succ(maxread));
  freemem(linep,sizex*3+4);
  loadpcx := errnoerror;
end;

function info_pcx(var stream : tstream32;var image_info : timageinfo) : word;
var
  h          : pcxh;
begin
  info_pcx := errfileerror;
  if (stream.status <> stok) then exit;
  stream.read32(farptr(@h),sizeof(h));

  if (h.id <> $0A) then begin
    info_pcx := errfalseformat;
    stream.done;
    exit;
  end;
  if i < sizeof(h) then begin
    info_pcx := errfileerror;
    stream.done;
    exit;
  end;
  with image_info do begin
    sizex        := h.maxx-h.minx;
    sizey        := h.maxy-h.miny;
    bpp          := h.bpp*h.nplanes;
    greyscale    := h.paltype = 2;
    alphachannel := false;
    transparency := false;
    compressed   := h.compression = 1;
    case h.compression of
      1 : comptype := 'RLE';
      else comptype := 'unknown';
    end;
    interlaced   := false;
    frames       := 1;
    trans_color  := 0;
    memsize      := longint(sizex)*sizey;
    disksize     := stream.getsize;
    supported    := (h.version = 5)and(h.bpp = 8)and(h.compression = 1);
    version      := h.version;
  end;
  stream.done;
  info_pcx := errnoerror;
end;

type
  bmpheader = record
    id         : array[0..1] of char;
    filesize   : longint;
    reserved   : array[0..3] of byte;
    imagestart : longint;
    headersize : longint;
  end;
  { Windows, OS/2 2+ }
  bmpinfoheader1 = record
    sizex      : longint;
    sizey      : longint;
    planes     : word;
    bpp        : word;
    comptype   : longint;{0:no compression;1: RLE 8 bit;2: RLE 4 bit}
    imagesize  : longint;
    hor_res    : longint;
    vert_res   : longint;
    usedcolors : longint;
    impcolors  : longint;{ Number of important colors}
    bluecomp   : byte;
    greencomp  : byte;
    redcomp    : byte;
    filler     : byte;
    { OS/2 2+           }
    reserved   : array[0..23] of byte;
  end;
  { OS/2 1.x         }
  bmpinfoheader2 = record
    sizex      : word;
    sizey      : word;
    planes     : word;
    bpp        : word;
  end;

  tbmppal = array[0..255] of trgb;
  tdchar = array[0..1] of char;

var
  h        : bmpheader;
  hi       : bmpinfoheader1;
  hi2      : bmpinfoheader2;
  bmppal   : tselector;
  count    : longint;
const
  validid : array[0..5] of tdchar=('BM','BA','CI','CP','IC','PT');

function info_bmp(var stream : tstream32;var image_info : timageinfo) : word;
var
  idvalid : boolean;
  i       : integer;
begin
  info_bmp := errfileerror;
  if (stream.status <> stok) then exit;
  stream.read32(farptr(@h),sizeof(h));
  if (stream.status <> stok) then exit;
  idvalid := false;
  for i := 0 to 5 do if h.id = validid[i] then idvalid := true;
  if (not idvalid) then begin
    info_bmp := errfalseformat;
    stream.done;
    exit;
  end;
  if (h.headersize > 12) then
    count := stream.read32(farptr(@hi),h.headersize-4) else
  begin
    count := stream.read32(farptr(@hi2),12);
    fillbyte(farptr(@hi),sizeof(hi)-4,0);
    hi.sizex  := hi2.sizex;
    hi.sizey  := hi2.sizey;
    hi.planes := hi2.planes;
    hi.bpp    := hi2.bpp;
  end;
  if (count < h.headersize-4) then begin
    info_bmp := errfalseformat;
    stream.done;
    exit;
  end;
  with image_info do begin
    sizex        := hi.sizex;
    sizey        := hi.sizey;
    bpp          := hi.bpp;
    greyscale    := false;
    alphachannel := false;
    transparency := false;
    compressed   := hi.comptype <> 0;
    case h.headersize of
      12 : subformat := 'OS/2 1.x';
      40 : subformat := 'Windows';
      64 : subformat := 'OS/2 2+';
      else subformat := 'unknown';
    end;
    case hi.comptype of
      0 : comptype := 'none';
      1 : comptype := 'RLE 8 bit';
      2 : comptype := 'RLE 4 bit';
      else comptype := 'unknown';
    end;
    interlaced   := false;
    frames       := 1;
    trans_color  := 0;
    memsize      := longint(sizex)*sizey;
    if bpp <= 8 then inc(memsize,(1 shl bpp) shl 4);
    disksize     := stream.getsize;
    supported    := hi.comptype = 0;
    version      := 1;
  end;
  stream.done;
  info_bmp := errnoerror;
end;

function loadbmp(var stream : tstream32;var image : timage;usebpp,flags : longint) : word;
var
  y,mempos    : word;
  lineread    : word;
  readmax     : word;
  imgpos      : longint;
  cnvx        : word;
  idvalid     : boolean;
  i           : integer;
  convertdata : tcnvproc;
  cnvtmp      : pcnvproc;
begin
  loadbmp := errfileerror;
  if (stream.status <> stok) then exit;
  stream.read32(farptr(@h),sizeof(h));

  if h.headersize > 12 then stream.read32(farptr(@hi),h.headersize-4) else
  begin
    stream.read32(farptr(@hi2),8);
    hi.sizex  := hi2.sizex;
    hi.sizey  := hi2.sizey;
    hi.planes := hi2.planes;
    hi.bpp    := hi2.bpp;
  end;

  idvalid := false;
  for y := 0 to 5 do if h.id = validid[y] then idvalid := true;
  if (not idvalid) then begin
    loadbmp := errfalseformat;
    stream.done;
    exit;
  end;

  if (hi.comptype <> 0)or(not hi.bpp in [1,4,8,24])
  then begin
    loadbmp := errfalseformat;
    stream.done;
    exit;
  end;
  if (stream.errorinfo <> stok) then begin
    loadbmp := errfalseend;
    stream.done;
    exit;
  end;

  cnvtmp  := prepareimage_cnv(image,hi.sizex,hi.sizey,hi.bpp,usebpp,0,flags,cnvimgmd);
  if (cnvtmp = nil) then begin
    loadbmp := errfalsebpp;
    stream.done;
    exit;
  end;
  convertdata := tcnvproc(cnvtmp);

  if (hi.bpp <= 8) then begin
    stream.read32(cnvpal,(word(1) shl hi.bpp) shl 2);
    if image.bpp > 8 then begin
      case image.bpp of
        15 : pal_32to15(cnvpal,cnvpal,(word(1) shl hi.bpp));
        16 : pal_32to16(cnvpal,cnvpal,(word(1) shl hi.bpp));
      end;
    end
  end;

  stream.seek(h.imagestart);
  lineread := ((longint(hi.sizex)*hi.bpp) shr 3+3) and not 3;

  maxread := 64000;
  readmax := (maxread div lineread)*lineread;
  getmem(p,succ(readmax));
  mempos := readmax;
  imgpos := longint(image.bpl)*pred(image.sizey);

  stream.seek(h.imagestart);
  dec(hi.sizey);

  cnvxpos := 0;
  cnvx := hi.sizex;
  if hi.bpp = 24 then cnvx := cnvx*3;
  if hi.bpp = image.bpp then cnvx := lineread;
  for y := hi.sizey downto 0 do begin
    if mempos = readmax then begin
      stream.read32(farptr(p),readmax);
      mempos := 0;
    end;
    cnvypos := y;
    convertdata(ptr48(seg(p^),ofs(p^)+mempos),ptr48(image.data,image.imagestart+imgpos),cnvx);
    dec(imgpos,image.bpl);
    inc(mempos,lineread);
  end;

  stream.done;
  freemem(p,succ(readmax));
  loadbmp := errnoerror;
end;

function savebmp(var stream : tstream32;var image : timage) : word;
var
  x,y         : word;
  linedata    : tselector;
  linesize    : word;
  lc          : longint;
  imgpos      : longint;
  convertdata : tcnvproc;
  cnvtmp      : pcnvproc;
begin
  savebmp := errfileerror;
  if (stream.status <> stok) then exit;
  with hi do begin
    sizex      := image.sizex;
    sizey      := image.sizey;
    planes     := 1;
    bpp        := image.bpp;
    if bpp >= 15 then bpp := 24;
    comptype   := 0;
    x := sizex*(bpp shr 3);
    if (x <> x and not 3) then x := (x and not 3)+4;
    imagesize  := x*sizey;
    hor_res    := sizex;
    vert_res   := sizey;
    usedcolors := longint(1) shl image.bpp;

(*  bmpinfoheader1 = record
    sizex      : longint;
    sizey      : longint;
    planes     : word;
    bpp        : word;
    comptype   : longint;{0:no compression;1: RLE 8 bit;2: RLE 4 bit}
    imagesize  : longint;
    hor_res    : longint;
    vert_res   : longint;
    usedcolors : longint;
    impcolors  : longint;{ Number of important colors}
    bluecomp   : byte;
    greencomp  : byte;
    redcomp    : byte;
    filler     : byte;
    { OS/2 2+           }
    reserved   : array[0..23] of byte;
  end;*)
    impcolors  := usedcolors;
    bluecomp   := 255;
    greencomp  := 255;
    redcomp    := 255;
  end;
  with h do begin
    id := 'BM';
    headersize := 40;
    if image.bpp <= 8 then imagestart := headersize-4+hi.usedcolors*4+sizeof(h)
    else imagestart := headersize-4+sizeof(h);
    filesize   := imagestart+hi.imagesize;
  end;
  savebmp := errnodiskmem;
  stream.write32(farptr(@h),sizeof(h));
  stream.write32(farptr(@hi),h.headersize-4);
  if (stream.status <> stok) then exit;
  if image.bpp <= 8 then
    stream.write32(ptr48(image.data,image.palstart),hi.usedcolors shl 2);
  case image.bpp of
    1 : linesize := ((hi.sizex+7) shr 3+3) and not 3;
    4 : linesize := ((hi.sizex+1) shr 1+3) and not 3;
    8 : linesize := (hi.sizex+3) and not 3;
    else linesize := (hi.sizex*3+3) and not 3;
  end;

  if image.bpp = hi.bpp then begin
    for y := 0 to image.sizey-1 do begin
      stream.write32(ptr48(image.data,
      image.imagestart+longint(image.bpl)*(image.sizey-y-1)),linesize);
      if (stream.status <> stok) then begin
        savebmp := errwriteerror;
        stream.done;
        exit;
      end;
    end;
  end else begin
    cnvtmp := getcnvproc(image.bpp,hi.bpp,cnvimgmd);
    if (cnvtmp = nil) then begin
      savebmp := errfalsebpp;
      stream.done;
      exit;
    end;
    convertdata := tcnvproc(cnvtmp);
    getmem32(linedata,linesize);
    imgpos := image.imagestart+pred(image.sizey)*image.bpl;
    for y := 0 to image.sizey-1 do begin
      convertdata(ptr48(image.data,imgpos),ptr48(linedata,0),image.sizex*image.pixel);
      stream.write32(ptr48(linedata,0),linesize);
      if (stream.status <> stok) then begin
        freemem32(linedata);
        exit;
      end;
      dec(imgpos,image.bpl);
    end;
    freemem32(linedata);
  end;
  stream.done;
  savebmp := errnoerror;
end;

function savepcx(var stream : tstream32;var image : timage) : word;
{ !! Saver still a bit buggy }
type
  tb = array[0..65528] of byte;
var
  linep,p      : pointer;
  h            : pcxh;
  x,y,i        : word;
  wc           : word;
  current,last : byte;
{  writecount   : word;}
  plane        : word;
  err          : word;
  imgpos       : longint;
  pal          : pointer;
  convertdata  : tcnvproc;
  cnvtmp       : pcnvproc;
{  pcxh = record
    id,version              : byte;
    compression             : byte;
    bpp                     : byte;
    minx,miny,
    maxx,maxy,
    dpix,dpiy               : word;
    pal16                   : array[0..47] of byte;
    reserved,nplanes        : byte;
    bytesperline,
    paltype                 : word;
    hscreensize,vscreensize : word;
    reserved2               : array[0..53] of byte;
  end;
}
begin
  if (image.bpp < 8) then begin
    savepcx := errfalsebpp;
    exit;
  end;
  savepcx := errfileerror;
  if (stream.status <> stok) then exit;
  fillbyte(farptr(@h),sizeof(h),0);
  with h do begin
    id           := $0A;
    version      := 5;
    compression  := 1;
    bpp          := 8;
    {Nice thing to fuck up some poor loaders if minx/miny <> 0...}
    minx         := 0;
    miny         := 0;
    maxx         := image.sizex-1;
    maxy         := image.sizey-1;
    dpix         := 75;
    dpiy         := 75;
    if image.bpp <= 8 then
    pal_32to24(ptr48(image.data,image.palstart),farptr(@pal16),16);
    reserved     := 0;
    if image.bpp <= 8 then nplanes := 1 else nplanes := 3;
    bytesperline := (maxx+2) and not 1;

    paltype      := 1;
    hscreensize  := image.sizex;
    vscreensize  := image.sizey;
  end;
  cnvtmp := getcnvproc(image.bpp,h.bpp*h.nplanes,cnvimgmd);
  if (cnvtmp = nil) then begin
    stream.done;
    savepcx := errfalsebpp;
    exit;
  end;
  convertdata := tcnvproc(cnvtmp);
  if (err <> errnoerror) then begin
    stream.done;
    savepcx := err;
    exit;
  end;
  savepcx := errnodiskmem;
  {$I-}stream.write32(farptr(@h),sizeof(h));{$I+}
  if (stream.status <> stok) then begin
    stream.done;
    exit;
  end;
  if (maxavail < (image.sizex+2)*5) then begin
    savepcx := errnomem;
    stream.done;
    exit;
  end;
  getmem(linep,image.sizex*3+4);
  getmem(p,(image.sizex+2)*2);
  imgpos := image.imagestart;

  for y := 0 to image.sizey-1 do begin
    convertdata(ptr48(image.data,imgpos),farptr(linep),image.sizex*image.pixel);
{    meml[seg(linep^):ofs(linep^)+image.sizex*3-3] := 0;}
    for plane := h.nplanes-1 downto 0 do begin
      wc := 0;
      last := tb(linep^)[plane];
      i := 1;
      for x := 1 to h.bytesperline-1 do
      begin
        current := tb(linep^)[x*h.nplanes+plane];
        if (last = current) then begin
          inc(i);
          if i = 63 then begin
            tb(p^)[wc] := i or $C0;
            tb(p^)[wc+1] := last;
            inc(wc,2);
            i := 1;
            inc(x);
            if x = h.bytesperline then break;
          end;
        end else begin
          if (i >= 1) then begin
            if (i = 1)and(last and $C0 <> $C0) then begin
              tb(p^)[wc] := last;
              inc(wc);
            end else begin
              tb(p^)[wc] := i or $C0;
              tb(p^)[wc+1] := last;
              inc(wc,2);
            end;
            i := 1;
          end;
        end;
       last := current;
      end;
      if (i >= 1) then begin
        if (i = 1)and(last and $C0 <> $C0) then begin
          tb(p^)[wc] := last;
          inc(wc);
        end else begin
          tb(p^)[wc] := i or $C0;
          tb(p^)[wc+1] := last;
          inc(wc,2);
        end;
      end;
      stream.write32(farptr(p),wc);
      if (stream.status <> stok) then begin
        savepcx := errnodiskmem;
        stream.done;
        freemem(linep,image.sizex*3+4);
        freemem(p,(image.sizex+2)*2);
        exit;
      end;
    end;
    inc(imgpos,image.bpl);
  end;
  if (image.bpp <= 8)and(image.flags and impalette <> 0) then begin
    wc := (word(1) shl image.bpp)*3;
    getmem(pal,wc);
    pal_32to24(ptr48(image.data,image.palstart),farptr(pal),word(1) shl image.bpp);
    current := 12;
    stream.write32(farptr(@current),1); { Read indicator }
    stream.write32(farptr(pal),wc);
    if (stream.status = stok) then savepcx := errnoerror;
    freemem(pal,wc);
  end else savepcx := errnoerror;
  stream.done;
  freemem(linep,image.sizex*3+4);
  freemem(p,(image.sizex+2)*2);
end;


begin
end.
