{$N+,E+}
uses crt,grafx2,gx_glob,stream32,dos,gx_font;

type
  tsarray = ARRAY[1..255] OF string[30];

PROCEDURE LoadDir(Name : string; VAR Prgs : tsarray; VAR Anz : byte);

  VAR  DirRec : SearchRec;
            i : integer;

PROCEDURE BSort(VAR So : tsarray; SAnz : word);

VAR  Temp : string[80];
        x : byte;
    Again : boolean;

BEGIN
  REPEAT
    Again:=false;

    FOR x:=1 TO SAnz-1 DO
      IF So[x]>So[x+1] THEN BEGIN
         Again:=true;
         Temp:=So[x]; So[x]:=So[x+1];
         So[x+1]:=Temp;
      END;
  UNTIL (NOT Again);
END;

BEGIN
    FOR i:=1 TO 255 DO BEGIN
       Prgs[i]:='';
    END;
    Anz:=0;
    FindFirst(Name,$20,DirRec);
    WHILE (DosError<>18) DO BEGIN
       Anz:=Anz+1;
       Prgs[Anz]:=DirRec.Name;
       IF Length(Prgs[Anz])>12 THEN BEGIN
          Prgs[Anz]:='';
          Anz:=0;
       END;
       FindNext(DirRec);
    END;
    IF Anz>0 THEN BSort(Prgs,Anz);
END;

var
  font    : txfn;
  screen  : tgxscreen;
  dats    : tsarray;
  i,num   : byte;
  y       : word;
  error   : boolean;
  s       : string;
  sizey   : integer;
  stream  : tfilestream32;
  size    : integer;


begin
  { Load all font names }
  loaddir('gx2fonts\*.XFN',dats,num);
  { Try to use the largest possible mode - strings are very wide }
    if not screen.init(800,600,clhi,mdauto) then
      if not screen.init(640,480,clhi,mdauto) then
        writeln(gxerror,'Error while initializing video mode');
  { Set font antialiasing for vector fonts - looks better }
  screen.setfontattributes(textdefault,textdefault,textantialias);
  y := 10;
  for i := 1 to num do
  begin
    stream.init('gx2fonts\'+dats[i],stopenread);
    error := not font.init(stream);
    stream.done;
    { If an error occured, we get here... }
    if error then begin
      { Set normal system font }
      { And put out error message }
      sysfont.write(screen,10,y,'Error while loading '+dats[i],screen.rgb(255,0,0));
      inc(y,sysfont.maxcharheight+2);
      if y > screen.mode.maxy-50 then begin
        readkey;
        screen.clear;
        y := 10;
      end;
    end else
    begin
      { Show, if available, ALL included subfonts }
      for size := 0 to font.numofsubfonts do
      begin
        if font.numofsubfonts > 0 then font.setfontsize(size);
        s := Dats[i]+' - The quick brown fox jumps over the lazy dog';
        sizey := font.height(s);
        { End of screen reached? Wait for user input and continue thereafter }
        if (y > screen.mode.maxy-sizey) then
        begin
          readkey;
          screen.clear;
          y := 10;
        end;
        font.write(screen,10,y,s,screen.rgb(255,255,255));
        screen.hline(0,y+sizey+1,screen.maxx+1,screen.rgb(0,0,255));
        inc(y,sizey+3);
      end;
    end;
    font.close;
  end;
  readkey;
  screen.close;
end.
