{ (c) 1996 Daniel Vollmer, rewrite from modeX to GrafX 2 interface, asm
  optimizations and x-interpolation (c) 1998 by Stefan Goehler
  This is a little example about how to access an image directly        }
program hicol;
{Undefine to use no x-interpolation - slightly faster}
{$DEFINE XINT}
uses crt,grafx2,gx_glob,gx_image,gx_fx;
var
  a,b,c,i           : integer;
  ctr,tectr         : word;
  sini              : array[0..255] of byte;
  x1,x2,x3,y1,y2,y3 : integer;
  y                 : word;
  cr,cg,cb          : word;
  screen            : tgxscreen;
  plasma            : timage;
  mempos            : longint;
  shiftval          : byte;
  endx              : word;
  exiting           : boolean;
  exfade            : integer;

begin
  for i := 0 to 255 do sini[i] := round(sin(i*pi/128)*127)+128;
  if not screen.init(320,240,clhitrue,mdauto+mdbestfit) then
   writeln(gxerror,'Error while initializing video mode');

  { Open the image where the plasma is drawn to... changing the size
    of the image here automatically resizes also the plasma          }
  check4fail(openimage(plasma,160,120,32,1,imdefault));

  { Try to change this value in a range of 0..9 or so: }
  shiftval := 6;

  endx    := plasma.sizex shr 1;
  exiting := false;
  exfade  := 256;
  repeat
    mempos := plasma.imagestart;
    for y := 0 to plasma.sizey-1 do begin
      a := sqr(y-y1)+sqr(x1);
      b := sqr(y-y2)+sqr(x2);
      c := sqr(y-y3)+sqr(x3);
      cr := sini[byte(a shr shiftval)];
      cg := sini[byte(b shr shiftval)];
      cb := sini[byte(c shr shiftval)];
      asm
                 xor   ax,ax
          db 66h;mov   di,mempos.word
                 mov   es,[plasma.data]
                 xor   dx,dx
          @lp:
                 mov   cl,shiftval
                 mov   bx,ax
                 push  ax
                 sub   bx,x3
{                 add   bx,bx}
                 add   bx,c
                 mov   c,bx
                 shr   bx,cl
                 and   bx,00FFh
                 mov   bl,sini.byte[bx]
                 mov   si,bx

                 mov   bx,ax
                 sub   bx,x2
{                 add   bx,bx}
                 add   bx,b
                 mov   b,bx
                 shr   bx,cl
                 and   bx,00FFh
                 mov   dl,sini.byte[bx]

                 mov   bx,ax
                 sub   bx,x1
{                 add   bx,bx}
                 add   bx,a
                 mov   a,bx
                 shr   bx,cl
                 and   bx,00FFh
                 mov   bl,sini.byte[bx]

{$IFDEF XINT}
                 mov   ax,bx
                 add   ax,cr
                 mov   cr,bx
          db 66h;shl   bx,16
          db 66h;shl   ax,15
                 mov   ax,dx
                 add   ax,cg
                 mov   cg,dx
                 shl   ax,7
                 mov   cx,si
                 add   cx,cb
                 mov   cb,si
                 shr   cx,1
                 mov   al,cl
          db 26h,67h,66h,89h,07h     {mov  es:[edi],eax}
                 mov   bx,si
                 mov   bh,cg.byte
          db 26h,67h,66h,89h,5Fh,04h {mov  es:[edi+4],ebx}
{$ELSE}
                 mov   ax,bx
          db 66h;shl   ax,16
                 mov   ax,si
                 mov   ah,dl
          db 26h,67h,66h,89h,07h     {mov  es:[edi],eax}
          db 26h,67h,66h,89h,47h,04h {mov  es:[edi+4],eax}
{$ENDIF}
          db 66h;add   di,8
                 pop   ax
                 inc   ax
                 cmp   ax,endx
                 jnae  @lp
          db 66h;mov   mempos.word,di
      end;
    end;
    if keypressed then exiting := true;
    if exiting then begin
      dec(exfade,4);
      if exfade < 0 then exfade := 0;
      brightness_image(plasma,plasma,exfade);
    end;
    screen.scale(0,0,screen.maxx+1,screen.maxy+1,plasma,drdefault);
    inc(ctr);
    tectr := ctr*10;
    x1 := sini[byte(tectr div 12)];
    x2 := sini[byte(tectr div 11)];
    x3 := sini[byte(ctr)];
    y1 := sini[byte(tectr shr 3+64)];
    y2 := sini[byte(tectr div 7+64)];
    y3 := sini[byte(tectr div 12+64)];
  until exfade = 0;
  while keypressed do readkey;
  closeimage(plasma);
  screen.close;
end.
