{$A+,B-,F+,G+,N+,P+,Q-,R-,T-,V+,X+}
{****************************************************************************
 * Truecolor driver for GX2 - copyright (c) 1998-1999 by Stefan Goehler     *
 * License agreement in gx2.txt - illegal copy without this file!           *
 * Complete package and new version always available here:                  *
 * http://sourcenet.home.pages.de                                           *
 ****************************************************************************}
{$IFNDEF DPMI}
  !Real mode not supported!
  This unit is fully 32 bit oriented, so forget about real mode.
  You need BP7 to use protected mode. If you have it, please
  switch at compiler/platform to PM (start bp.exe!)
{$ENDIF}
unit drv_2432;
interface
uses newfrontier,gx_glob;

  procedure   hline_32_bnk(x1,y1,sizex,col : longint;var mode : tmode);
  procedure   pline_32_bnk(x1,y1,sizex: integer;col,flags : longint;var mode : tmode);
  procedure   vline_32_bnk(x1,y1,sizey: integer;col : longint;var mode : tmode);
  procedure   hline_24_lin(x1,y1,sizex,col : longint;var mode : tmode);
  procedure   hline_32_lin(x1,y1,sizex,col : longint;var mode : tmode);
  procedure   pline_24_lin(x1,y1,sizex: integer;col,flags : longint;var mode : tmode);
  procedure   pline_32_lin(x1,y1,sizex: integer;col,flags : longint;var mode : tmode);
  procedure   vline_24_lin(x1,y1,sizey: integer;col : longint;var mode : tmode);
  procedure   vline_32_lin(x1,y1,sizey: integer;col : longint;var mode : tmode);
  procedure   addp_24_lin(x,y,col : longint;var mode : tmode);
  procedure   addp_32_lin(x,y,col : longint;var mode : tmode);
  procedure   subp_24_lin(x,y,col : longint;var mode : tmode);
  procedure   subp_32_lin(x,y,col : longint;var mode : tmode);
  procedure   addp_32_bnk(x,y,col : longint;var mode : tmode);
  procedure   subp_32_bnk(x,y,col : longint;var mode : tmode);
  procedure   pp_32_lin(x,y,col : longint;var mode : tmode);
  procedure   pp_32_bnk(x,y,col : longint;var mode : tmode);
  procedure   ap_24_lin(x,y,col : longint;alpha : byte;var mode : tmode);
  procedure   ap_32_lin(x,y,col : longint;alpha : byte;var mode : tmode);
  procedure   ap_32_bnk(x,y,col : longint;alpha : byte;var mode : tmode);
  function    gp_32_lin(x,y : longint;var mode : tmode) : longint;
  function    gp_32_bnk(x,y : longint;var mode : tmode) : longint;

  procedure   pp_24_lin(x,y,col : longint;var mode : tmode);
  procedure   pp_24_bnk(x,y,col : longint;var mode : tmode);
  function    gp_24_lin(x,y : longint;var mode : tmode) : longint;
  function    gp_24_bnk(x,y : longint;var mode : tmode) : longint;
{  procedure   fillrect_24_lin(x1,y1,sizex,sizey,col,flags : longint;var mode : tmode);
  procedure   fillrect_32_bnk(x1,y1,sizex,sizey,col,flags : longint;var mode : tmode);
  procedure   fillrect_32_lin(x1,y1,sizex,sizey,col,flags : longint;var mode : tmode);}
  procedure   line_32_bnk(x1,y1,x2,y2,col : longint;var mode : tmode);
  procedure   line_32_lin(x1,y1,x2,y2,col : longint;var mode : tmode);
  procedure   line_24_lin(x1,y1,x2,y2,col : longint;var mode : tmode);

  function    calcofs_32_lin(x,y : integer;var mode): longint;
  function    calcofs_32_bnk(x,y : integer;var mode) : longint;
  function    calcofs_24_lin(x,y : integer;var mode): longint;
  function    calcofs_24_bnk(x,y : integer;var mode) : longint;

implementation

procedure hline_32_bnk(x1,y1,sizex,col : longint;var mode : tmode);assembler;
asm
  mov   cx,sizex.word
  mov   ax,x1.word
  or    cx,cx
  jz    @endofproc
  jns   @next
    neg   cx
    sub   ax,cx
  @next:
  les   di,mode
  add   ax,es:[di].tmode.actviewport.x1.word
  mov   bx,ax
  add   bx,cx
  mov   si,y1.word
  add   si,es:[di].tmode.actviewport.y1.word
  cmp   si,es:[di].tmode.actviewport.y1.word
  jl    @endofproc
  cmp   si,es:[di].tmode.actviewport.y2.word
  jg    @endofproc
  mov   cx,es:[di].tmode.actviewport.x1.word
  mov   dx,es:[di].tmode.actviewport.x2.word
  cmp   ax,dx
  jg    @endofproc
  cmp   bx,cx
  jl    @endofproc
  cmp   ax,cx
  jnl   @next1
     mov   ax,cx
  @next1:
  inc   dx
  cmp   bx,dx
  jng   @next2
     mov   bx,dx
  @next2:
  sub   bx,ax
  shl   bx,2
  mov   sizex.word,bx
  mov   x1.word,ax
  add   si,es:[di].tmode.pageadd.word
  mov   y1.word,si
  mov   bx,es:[di].tmode.writeptr
  push  bx

  push  ax
  push  si
  push  es
  push  di
  call  es:[di].tmode.calcofs
  pop   bx
  mov   cx,ax
  add   ax,sizex.word
  jc    @overflow
    push   bx
    push   0
    push   cx
    push   0
    push   sizex.word
    db 66h;push   col.word
    call   fill32screen
  jmp  @endofproc
  @overflow:
    xor    ax,ax
    sub    ax,cx
    push   bx
    push   ax

    push   bx
    push   0
    push   cx
    push   0
    push   ax
    db 66h;push   col.word
    call   fill32screen
    call   incbank
    pop    ax
    pop    bx
    mov    cx,sizex.word
    sub    cx,ax
    push   bx
    push   0
    push   0
    push   0
    push   cx
    db 66h;push   col.word
    call   fill32screen
  @endofproc:
end;

procedure pline_32_bnk(x1,y1,sizex: integer;col,flags : longint;var mode : tmode);
var
  i,mempos,overlap : word;
  fill        : procedure(dest : pointer48;count,value : longint);
  fillpatt    : procedure(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
label
  endofproc;
begin
  asm
    mov   cx,sizex
    mov   ax,x1
    or    cx,cx
    jz    endofproc
    jns   @next
      neg   cx
      sub   ax,cx
    @next:
    les   di,mode
    add   ax,es:[di].tmode.actviewport.x1.word
    mov   bx,ax
    add   bx,cx
    mov   si,y1
    add   si,es:[di].tmode.actviewport.y1.word
    cmp   si,es:[di].tmode.actviewport.y1.word
    jl    endofproc
    cmp   si,es:[di].tmode.actviewport.y2.word
    jg    endofproc
    mov   cx,es:[di].tmode.actviewport.x1.word
    mov   dx,es:[di].tmode.actviewport.x2.word
    cmp   ax,dx
    jg    endofproc
    cmp   bx,cx
    jl    endofproc
    cmp   ax,cx
    jnl   @next1
       mov   ax,cx
    @next1:
    inc   dx
    cmp   bx,dx
    jng   @next2
       mov   bx,dx
    @next2:
    sub   bx,ax
    mov   x1,ax
    shl   bx,2
    jz    endofproc
    add   si,es:[di].tmode.pageadd.word
    mov   sizex,bx
    mov   y1,si
  end;
  mempos := mode.calcofs(x1,y1,mode);
  if mode.pattern[0] = 1 then begin
    fill := fill32screen;
    case flags shr 24 of
      $00 :;
      $01 : fill := subfill_32;
      $02 : fill := addfill_32;
      $04 : fill := fillxor_32;
    end;
    if mempos < mempos+word(sizex) then
    fill(ptr48(mode.writeptr,mempos),sizex,col)
    else begin
      overlap := -mempos;
      if sizex > 0 then
      fill(ptr48(mode.writeptr,mempos),overlap,col);
      incbank;
      fill(ptr48(mode.writeptr,0),(sizex-overlap),col);
    end;
  end else begin
    fillpatt := fillpatt_32;
    case flags shr 24 of
      $00 :;
      $01 : fillpatt := pattsub_32;
      $02 : fillpatt := pattadd_32;
      $04 : fillpatt := pattxor_32;
    end;
    if mempos < mempos+word(sizex) then
    fillpatt(ptr48(mode.writeptr,mempos),sizex,col,x1,mode.pattern[y1 and 7+1])
    else begin
      overlap := -mempos;
      fillpatt(ptr48(mode.writeptr,mempos),overlap,col,x1,mode.pattern[y1 and 7+1]);
      incbank;
      fillpatt(ptr48(mode.writeptr,0),sizex-overlap,col,mempos-overlap,mode.pattern[i and 7+1]);
    end;
  end;
  endofproc:
end;

procedure vline_32_bnk(x1,y1,sizey: integer;col : longint;var mode : tmode);assembler;
asm
  les   di,mode
  mov   cx,sizey
  mov   ax,y1
  or    cx,cx
  jz    @end
  jns   @next
    neg   cx
    sub   ax,cx
  @next:
  add   ax,es:[di].tmode.actviewport.y1.word
  mov   bx,ax
  add   bx,cx
  mov   si,x1
  add   si,es:[di].tmode.actviewport.x1.word
  cmp   si,es:[di].tmode.actviewport.x1.word
  jl    @end
  cmp   si,es:[di].tmode.actviewport.x2.word
  jg    @end
  mov   cx,es:[di].tmode.actviewport.y1.word
  mov   dx,es:[di].tmode.actviewport.y2.word
  cmp   ax,dx
  jg    @end
  cmp   bx,cx
  jl    @end
  cmp   ax,cx
  jnl   @next1
    mov   ax,cx
  @next1:
  inc   dx
  cmp   bx,dx
  jng   @next2
    mov   bx,dx
  @next2:
  sub   bx,ax
  jz    @end
  mov   sizey,bx
  add   ax,es:[di].tmode.pageadd.word
  push  si
  push  ax
  push  es
  push  di
  call  es:[di].tmode.calcofs
  les   di,mode
  mov   bx,es:[di].tmode.bpl.word
  mov   es,es:[di].tmode.writeptr
  mov   di,ax
  db 66h;mov   ax,word ptr col
  mov   cx,sizey
      @lp:
      db 66h;mov   es:[di],ax
      add   di,bx
      jc    @nextbank
      @again:
      dec    cx
      jnz    @lp
    jmp    @end
       @nextbank:
       call  incbank
       jmp   @again
    @end:
end;

procedure hline_24_lin(x1,y1,sizex,col : longint;var mode : tmode);assembler;
asm
  mov   cx,sizex.word
  mov   ax,x1.word
  or    cx,cx
  jz    @endofproc
  jns   @next
    neg   cx
    sub   ax,cx
  @next:
  les   di,mode
  add   ax,es:[di].tmode.actviewport.x1.word
  mov   bx,ax
  add   bx,cx
  mov   si,y1.word
  add   si,es:[di].tmode.actviewport.y1.word
  cmp   si,es:[di].tmode.actviewport.y1.word
  jl    @endofproc
  cmp   si,es:[di].tmode.actviewport.y2.word
  jg    @endofproc
  mov   cx,es:[di].tmode.actviewport.x1.word
  mov   dx,es:[di].tmode.actviewport.x2.word
  cmp   ax,dx
  jg    @endofproc
  cmp   bx,cx
  jl    @endofproc
  cmp   ax,cx
  jnl   @next1
     mov   ax,cx
  @next1:
  inc   dx
  cmp   bx,dx
  jng   @next2
     mov   bx,dx
  @next2:
  sub   bx,ax
  mov   x1.word,ax
  mov   ax,bx
  add   bx,bx
  add   ax,bx
  mov   sizex.word,ax
  add   si,es:[di].tmode.pageadd.word
  mov   y1.word,si
  mov   bx,es:[di].tmode.writeptr
  mov   si,x1.word
  mov   cx,es:[di].tmode.bpl.word
  mov   ax,y1.word
  mul   cx
  add   ax,si
  adc   dx,0
  add   si,si
  add   ax,si
  adc   dx,0

    push   bx

    push   dx
    push   ax

    push   0
    push   sizex.word
    db 66h;push   col.word
    call   gx_glob.fill24screen
  @endofproc:
end;

procedure hline_32_lin(x1,y1,sizex,col : longint;var mode : tmode);assembler;
asm
  db 66h;mov   cx,sizex.word
  db 66h;mov   ax,x1.word
  db 66h;or    cx,cx
         jz    @endofproc
         jns   @next
           db 66h;neg   cx
           db 66h;sub   ax,cx
  @next:
         les   di,mode
  db 66h;add   ax,es:[di].tmode.actviewport.x1.word
  db 66h;mov   bx,ax
  db 66h;add   bx,cx

  db 66h;mov   si,y1.word
  db 66h;add   si,es:[di].tmode.actviewport.y1.word
  db 66h;cmp   si,es:[di].tmode.actviewport.y1.word
         jl    @endofproc
  db 66h;cmp   si,es:[di].tmode.actviewport.y2.word
         jg    @endofproc
  db 66h;mov   cx,es:[di].tmode.actviewport.x1.word
  db 66h;mov   dx,es:[di].tmode.actviewport.x2.word
  db 66h;cmp   ax,dx
         jg    @endofproc
  db 66h;cmp   bx,cx
         jl    @endofproc
  db 66h;cmp   ax,cx
         jnl   @next1
  db 66h;mov   ax,cx
  @next1:
  db 66h;inc   dx
  db 66h;cmp   bx,dx
         jng   @next2
  db 66h;mov   bx,dx
  @next2:
  db 66h;sub   bx,ax
  db 66h;shl   bx,2
  db 66h;mov   y1.word,si
  db 66h;mov   si,ax
  db 66h;mov   cx,es:[di].tmode.bpl.word
  db 66h;shl   si,2
  db 66h;mov   ax,y1.word
  db 66h;mul   cx
  db 66h;add   ax,si
  db 66h;add   ax,es:[di].tmode.displayofs.word
           push   es:[di].tmode.writeptr
    db 66h;push   ax
    db 66h;push   bx
    db 66h;push   col.word
    call   gx_glob.fill32screen
  @endofproc:
end;

procedure pline_24_lin(x1,y1,sizex: integer;col,flags : longint;var mode : tmode);
var
  mempos   : longint;
  fill     : procedure(dest : pointer48;count : longint;data : longint);
  fillpatt : procedure(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
label
  endofproc;
begin
  asm
    mov   cx,sizex
    mov   ax,x1
    or    cx,cx
    jz    endofproc
    jns   @next
      neg   cx
      sub   ax,cx
    @next:
    les   di,mode
    add   ax,es:[di].tmode.actviewport.x1.word
    mov   bx,ax
    add   bx,cx
    mov   si,y1
    add   si,es:[di].tmode.actviewport.y1.word
    cmp   si,es:[di].tmode.actviewport.y1.word
    jl    endofproc
    cmp   si,es:[di].tmode.actviewport.y2.word
    jg    endofproc
    mov   cx,es:[di].tmode.actviewport.x1.word
    mov   dx,es:[di].tmode.actviewport.x2.word
    cmp   ax,dx
    jg    endofproc
    cmp   bx,cx
    jl    endofproc
    cmp   ax,cx
    jnl   @next1
       mov   ax,cx
    @next1:
    inc   dx
    cmp   bx,dx
    jng   @next2
       mov   bx,dx
    @next2:
    sub   bx,ax
    mov   cx,bx
    add   bx,bx
    add   bx,cx
    jz    endofproc
    mov   sizex,bx
    mov   x1,ax
    mov   bx,es:[di].tmode.writeptr
    mov   y1,si
    db 66h;xor   si,si
           mov   si,x1
    db 66h;mov   cx,es:[di].tmode.bpl.word
    db 66h;xor   ax,ax
           mov   ax,y1
    db 66h;mul   cx
    db 66h;add   ax,si
    db 66h;add   si,si
    db 66h;add   ax,si
    db 66h;add   ax,es:[di].tmode.displayofs.word
    db 66h;mov   mempos.word,ax
  end;
  if mode.pattern[0] = 1 then begin
    fill := fill24screen;
    case flags shr 24 of
      $00 :;
      $01 : fill := subfill_24_386;
      $02 : fill := addfill_24_386;
      $04 : fill := fillxor_24_386;
    end;
    fill(ptr48(mode.writeptr,mempos),sizex,col);
  end else begin
    fillpatt := fillpatt_24;
    case flags shr 24 of
      $00 :;
      $01 : fillpatt := pattsub_24_386;
      $02 : fillpatt := pattadd_24_386;
      $04 : fillpatt := pattxor_24_386;
    end;
    fillpatt(ptr48(mode.writeptr,mempos),sizex,col,x1,mode.pattern[y1 and 7+1]);
  end;
  endofproc:
end;

procedure pline_32_lin(x1,y1,sizex: integer;col,flags : longint;var mode : tmode);
var
  mempos   : longint;
  fill     : procedure(dest : pointer48;count : longint;data : longint);
  fillpatt : procedure(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
label
  endofproc;
begin
  asm
    mov   cx,sizex
    mov   ax,x1
    or    cx,cx
    jz    endofproc
    jns   @next
      neg   cx
      sub   ax,cx
    @next:
    les   di,mode
    add   ax,es:[di].tmode.actviewport.x1.word
    mov   bx,ax
    add   bx,cx
    mov   si,y1
    add   si,es:[di].tmode.actviewport.y1.word
    cmp   si,es:[di].tmode.actviewport.y1.word
    jl    endofproc
    cmp   si,es:[di].tmode.actviewport.y2.word
    jg    endofproc
    mov   cx,es:[di].tmode.actviewport.x1.word
    mov   dx,es:[di].tmode.actviewport.x2.word
    cmp   ax,dx
    jg    endofproc
    cmp   bx,cx
    jl    endofproc
    cmp   ax,cx
    jnl   @next1
       mov   ax,cx
    @next1:
    inc   dx
    cmp   bx,dx
    jng   @next2
       mov   bx,dx
    @next2:
    sub   bx,ax
    shl   bx,2
    jz    endofproc
    mov   sizex,bx
    mov   x1,ax
    mov   bx,es:[di].tmode.writeptr
    mov   y1,si
    db 66h;xor   si,si
           mov   si,x1
    db 66h;mov   cx,es:[di].tmode.bpl.word
    db 66h;xor   ax,ax
    db 66h;shl   si,2
           mov   ax,y1
    db 66h;mul   cx
    db 66h;add   ax,si
    db 66h;add   ax,es:[di].tmode.displayofs.word
    db 66h;mov   mempos.word,ax
  end;
  if mode.pattern[0] = 1 then begin
    fill := fill32screen;
    case flags shr 24 of
      $00 :;
      $01 : fill := subfill_32;
      $02 : fill := addfill_32;
      $04 : fill := fillxor_32;
    end;
    fill(ptr48(mode.writeptr,mempos),sizex,col);
  end else begin
    fillpatt := fillpatt_32;
    case flags shr 24 of
      $00 :;
      $01 : fillpatt := pattsub_32;
      $02 : fillpatt := pattadd_32;
      $04 : fillpatt := pattxor_32;
    end;
    fillpatt(ptr48(mode.writeptr,mempos),sizex,col,x1,mode.pattern[y1 and 7+1]);
  end;
  endofproc:
end;

procedure vline_24_lin(x1,y1,sizey: integer;col : longint;var mode : tmode);assembler;
asm
  les   di,mode
  mov   cx,sizey
  mov   ax,y1
  or    cx,cx
  jz    @end
  jns   @next
    neg   cx
    sub   ax,cx
  @next:
  add   ax,es:[di].tmode.actviewport.y1.word
  mov   bx,ax
  add   bx,cx
  mov   si,x1
  add   si,es:[di].tmode.actviewport.x1.word
  cmp   si,es:[di].tmode.actviewport.x1.word
  jl    @end
  cmp   si,es:[di].tmode.actviewport.x2.word
  jg    @end
  mov   cx,es:[di].tmode.actviewport.y1.word
  mov   dx,es:[di].tmode.actviewport.y2.word
  cmp   ax,dx
  jg    @end
  cmp   bx,cx
  jl    @end
  cmp   ax,cx
  jnl   @next1
    mov   ax,cx
  @next1:
  inc   dx
  cmp   bx,dx
  jng   @next2
    mov   bx,dx
  @next2:
  sub   bx,ax
  jz    @end
  mov   cx,word ptr es:[di].tmode.bpl
  mul   cx
  mov   cx,si
  add   si,si
  add   cx,si
  add   ax,cx
  adc   dx,0

  db 66h;mov   cx,es:[di].tmode.bpl.word
  mov   si,dx
  db 66h;shl  si,16
  mov   si,ax
  mov   ax,word ptr col
  db 66h;add   si,es:[di].tmode.displayofs.word
  mov   es,es:[di].tmode.writeptr
  mov   dx,col.word
  mov   al,col.byte[2]
  @lp:
    db 26h, 67h,89h,16h {mov es:[esi],si}
    db 26h, 67h,88h,46h,02h {mov es:[esi+2],al}
    db 66h;add   si,cx
           dec   bx
  jnz    @lp
  @end:
end;

procedure vline_32_lin(x1,y1,sizey: integer;col : longint;var mode : tmode);assembler;
asm
  les   di,mode
  mov   cx,sizey
  mov   ax,y1
  or    cx,cx
  jz    @end
  jns   @next
    neg   cx
    sub   ax,cx
  @next:
  add   ax,es:[di].tmode.actviewport.y1.word
  mov   bx,ax
  add   bx,cx
  mov   si,x1
  add   si,es:[di].tmode.actviewport.x1.word
  cmp   si,es:[di].tmode.actviewport.x1.word
  jl    @end
  cmp   si,es:[di].tmode.actviewport.x2.word
  jg    @end
  mov   cx,es:[di].tmode.actviewport.y1.word
  mov   dx,es:[di].tmode.actviewport.y2.word
  cmp   ax,dx
  jg    @end
  cmp   bx,cx
  jl    @end
  cmp   ax,cx
  jnl   @next1
    mov   ax,cx
  @next1:
  inc   dx
  cmp   bx,dx
  jng   @next2
    mov   bx,dx
  @next2:
  sub   bx,ax
  jz    @end
  mov   cx,word ptr es:[di].tmode.bpl
  shl   si,2
  mul   cx
  add   ax,si
  adc   dx,0

  db 66h;mov   cx,es:[di].tmode.bpl.word
  mov   si,dx
  db 66h;shl  si,16
  mov   si,ax
  db 66h;mov   ax,word ptr col
  db 66h;add   si,es:[di].tmode.displayofs.word
  mov   es,es:[di].tmode.writeptr
  @lp:
    db 26h,67h,66h,89h,06h {mov es:[esi],eax}
    db 66h;add   si,cx
           dec   bx
  jnz    @lp
  @end:
end;


procedure addp_24_lin(x,y,col : longint;var mode : tmode);assembler;
asm
         les   di,mode
  db 66h;mov   bx,x.word
  db 66h;cmp   bx,0
         jl    @end
  db 66h;add   bx,es:[di].tmode.actviewport.x1.word
  db 66h;cmp   bx,es:[di].tmode.actviewport.x2.word
         jg    @end
  db 66h;mov   cx,es:[di].tmode.bpl.word
  db 66h;mov   ax,y.word
  db 66h;cmp   ax,0;dw 0000h
         jl    @end
  db 66h;add   ax,es:[di].tmode.actviewport.y1.word
  db 66h;cmp   ax,es:[di].tmode.actviewport.y2.word
         jg    @end
  db 66h;mul   cx
  db 66h;add   ax,es:[di].tmode.displayofs.word
         mov   es,es:[di].tmode.writeptr
  db 67h,66h,8Dh,3Ch,98h { lea edi,[eax+ebx*4] }
  db 26h,67h,66h,8Bh,07h { mov eax,es:[edi]    }

         add    al,col.trgb.b
         jnc    @nc_b
           mov    al,255
         @nc_b:

         add    ah,col.trgb.g
         jnc    @nc_g
           mov    ah,255
         @nc_g:

  db 66h;mov   dx,ax
  db 66h;shr   dx,16
         add    dl,col.trgb.r
         jnc    @nc_r
           mov    dl,255
         @nc_r:
  db 26h,67h,89h,07h     { mov es:[edi],ax     }
  db 26h,67h,88h,57h,02h { mov es:[edi+2],dl   }
 @end:
end;

procedure addp_32_lin(x,y,col : longint;var mode : tmode);assembler;
asm
         les   di,mode
  db 66h;mov   bx,x.word
  db 66h;cmp   bx,0
         jl    @end
  db 66h;add   bx,es:[di].tmode.actviewport.x1.word
  db 66h;cmp   bx,es:[di].tmode.actviewport.x2.word
         jg    @end
  db 66h;mov   cx,es:[di].tmode.bpl.word
  db 66h;mov   ax,y.word
  db 66h;cmp   ax,0;dw 0000h
         jl    @end
  db 66h;add   ax,es:[di].tmode.actviewport.y1.word
  db 66h;cmp   ax,es:[di].tmode.actviewport.y2.word
         jg    @end
  db 66h;mul   cx
  db 66h;add   ax,es:[di].tmode.displayofs.word
         mov   es,es:[di].tmode.writeptr
  db 67h,66h,8Dh,3Ch,98h { lea edi,[eax+ebx*4] }
  db 26h,67h,66h,8Bh,07h { mov eax,es:[edi]    }

         add    al,col.trgb.b
         jnc    @nc_b
           mov    al,255
         @nc_b:

         add    ah,col.trgb.g
         jnc    @nc_g
           mov    ah,255
         @nc_g:

  db 66h;mov   dx,ax
  db 66h;shr   dx,16
         add    dl,col.trgb.r
         jnc    @nc_r
           mov    dl,255
         @nc_r:
  db 66h;shl   dx,16
  db 66h,25h,0FFh,0FFh,00h,00h { and eax,0FFFFh   }
  db 66h;or    ax,dx
  db 26h,67h,66h,89h,07h       { mov es:[edi],eax }
 @end:
end;

procedure subp_24_lin(x,y,col : longint;var mode : tmode);assembler;
asm
         les   di,mode
  db 66h;mov   bx,x.word
  db 66h;cmp   bx,0
         jl    @end
  db 66h;add   bx,es:[di].tmode.actviewport.x1.word
  db 66h;cmp   bx,es:[di].tmode.actviewport.x2.word
         jg    @end
  db 66h;mov   cx,es:[di].tmode.bpl.word
  db 66h;mov   ax,y.word
  db 66h;cmp   ax,0;dw 0000h
         jl    @end
  db 66h;add   ax,es:[di].tmode.actviewport.y1.word
  db 66h;cmp   ax,es:[di].tmode.actviewport.y2.word
         jg    @end
  db 66h;mul   cx
  db 66h;add   ax,es:[di].tmode.displayofs.word
         mov   es,es:[di].tmode.writeptr
  db 67h,66h,8Dh,3Ch,98h { lea edi,[eax+ebx*4] }
  db 26h,67h,66h,8Bh,07h { mov eax,es:[edi]    }

         sub    al,col.trgb.b
         jnc    @nc_b
           mov    al,0
         @nc_b:

         sub    ah,col.trgb.g
         jnc    @nc_g
           mov    ah,0
         @nc_g:

  db 66h;mov   dx,ax
  db 66h;shr   dx,16
         sub    dl,col.trgb.r
         jnc    @nc_r
           mov    dl,0
         @nc_r:
  db 26h,67h,89h,07h     { mov es:[edi],ax     }
  db 26h,67h,88h,57h,02h { mov es:[edi+2],dl   }
 @end:
end;

procedure subp_32_lin(x,y,col : longint;var mode : tmode);assembler;
asm
         les   di,mode
  db 66h;mov   bx,x.word
  db 66h;cmp   bx,0
         jl    @end
  db 66h;add   bx,es:[di].tmode.actviewport.x1.word
  db 66h;cmp   bx,es:[di].tmode.actviewport.x2.word
         jg    @end
  db 66h;mov   cx,es:[di].tmode.bpl.word
  db 66h;mov   ax,y.word
  db 66h;cmp   ax,0;dw 0000h
         jl    @end
  db 66h;add   ax,es:[di].tmode.actviewport.y1.word
  db 66h;cmp   ax,es:[di].tmode.actviewport.y2.word
         jg    @end
  db 66h;mul   cx
  db 66h;add   ax,es:[di].tmode.displayofs.word
         mov   es,es:[di].tmode.writeptr
  db 67h,66h,8Dh,3Ch,98h { lea edi,[eax+ebx*4] }
  db 26h,67h,66h,8Bh,07h { mov eax,es:[edi]    }

         sub    al,col.trgb.b
         jnc    @nc_b
           mov    al,0
         @nc_b:

         sub    ah,col.trgb.g
         jnc    @nc_g
           mov    ah,0
         @nc_g:

  db 66h;mov   dx,ax
  db 66h;shr   dx,16
         sub    dl,col.trgb.r
         jnc    @nc_r
           mov    dl,0
         @nc_r:
  db 66h;shl   dx,16
  db 66h,25h,0FFh,0FFh,00h,00h { and eax,0FFFFh }
  db 66h;or    ax,dx
  db 26h,67h,66h,89h,07h { mov es:[edi],eax }
 @end:
end;

procedure addp_32_bnk(x,y,col : longint;var mode : tmode);assembler;
asm
         les   di,mode
  db 66h;mov   bx,x.word
  db 66h;cmp   bx,0
         jl    @end
  db 66h;add   bx,es:[di].tmode.actviewport.x1.word
  db 66h;cmp   bx,es:[di].tmode.actviewport.x2.word
         jg    @end
         mov   cx,es:[di].tmode.bpl.word
  db 66h;mov   ax,y.word
  db 66h;cmp   ax,0;dw 0000h
         jl    @end
  db 66h;add   ax,es:[di].tmode.actviewport.y1.word
  db 66h;cmp   ax,es:[di].tmode.actviewport.y2.word
         jg    @end
  db 66h;add   ax,es:[di].tmode.pageadd.word
         shl   bx,2
         mul   cx
         add   ax,bx
         adc   dx,0
         mov   si,ax
         cmp   dx,lastbank
         je    @next
         push  si
         push  dx
         call  setbank
         les   di,mode
         pop   si
 @next:  mov   es,es:[di].tmode.writeptr
  db 66h;mov   ax,es:[di]

         add    al,col.trgb.b
         jnc    @nc_b
           mov    al,255
         @nc_b:

         add    ah,col.trgb.g
         jnc    @nc_g
           mov    ah,255
         @nc_g:

  db 66h;mov   dx,ax
  db 66h;shr   dx,16
         add    dl,col.trgb.r
         jnc    @nc_r
           mov    dl,255
         @nc_r:
  db 66h;shl   dx,16
  db 66h,25h,0FFh,0FFh,00h,00h { and eax,0FFFFh   }
  db 66h;or    ax,dx
  db 66h;mov   es:[di],ax
 @end:
end;

procedure subp_32_bnk(x,y,col : longint;var mode : tmode);assembler;
asm
         les   di,mode
  db 66h;mov   bx,x.word
  db 66h;cmp   bx,0
         jl    @end
  db 66h;add   bx,es:[di].tmode.actviewport.x1.word
  db 66h;cmp   bx,es:[di].tmode.actviewport.x2.word
         jg    @end
         mov   cx,es:[di].tmode.bpl.word
  db 66h;mov   ax,y.word
  db 66h;cmp   ax,0;dw 0000h
         jl    @end
  db 66h;add   ax,es:[di].tmode.actviewport.y1.word
  db 66h;cmp   ax,es:[di].tmode.actviewport.y2.word
         jg    @end
  db 66h;add   ax,es:[di].tmode.pageadd.word
         shl   bx,2
         mul   cx
         add   ax,bx
         adc   dx,0
         mov   si,ax
         cmp   dx,lastbank
         je    @next
         push  si
         push  dx
         call  setbank
         les   di,mode
         pop   si
 @next:  mov   es,es:[di].tmode.writeptr
  db 66h;mov   ax,es:[di]

         sub    al,col.trgb.b
         jnc    @nc_b
           mov    al,0
         @nc_b:

         sub    ah,col.trgb.g
         jnc    @nc_g
           mov    ah,0
         @nc_g:

  db 66h;mov   dx,ax
  db 66h;shr   dx,16
         sub    dl,col.trgb.r
         jnc    @nc_r
           mov    dl,0
         @nc_r:
  db 66h;shl   dx,16
  db 66h,25h,0FFh,0FFh,00h,00h { and eax,0FFFFh }
  db 66h;or    ax,dx
  db 66h;mov   es:[di],ax
 @end:
end;

procedure pp_32_lin(x,y,col : longint;var mode : tmode);assembler;
asm
         les   di,mode
  db 66h;mov   bx,x.word
  db 66h;cmp   bx,0
         jl    @end
  db 66h;add   bx,es:[di].tmode.actviewport.x1.word
  db 66h;cmp   bx,es:[di].tmode.actviewport.x2.word
         jg    @end
  db 66h;mov   cx,es:[di].tmode.bpl.word
  db 66h;mov   ax,y.word
  db 66h;cmp   ax,0;dw 0000h
         jl    @end
  db 66h;add   ax,es:[di].tmode.actviewport.y1.word
  db 66h;cmp   ax,es:[di].tmode.actviewport.y2.word
         jg    @end
  db 66h;mul   cx
  db 66h;mov   cx,col.word
  db 66h;add   ax,es:[di].tmode.displayofs.word
  mov   es,es:[di].tmode.writeptr
  db 26h,67h,66h,89h,0Ch,98h {mov es:[eax+ebx*4],ecx}
 @end:
end;

procedure pp_32_bnk(x,y,col : longint;var mode : tmode);assembler;
asm
         les   di,mode
  db 66h;mov   bx,x.word
  db 66h;cmp   bx,0
         jl    @end
  db 66h;add   bx,es:[di].tmode.actviewport.x1.word
  db 66h;cmp   bx,es:[di].tmode.actviewport.x2.word
         jg    @end
         mov   cx,es:[di].tmode.bpl.word
  db 66h;mov   ax,y.word
  db 66h;cmp   ax,0;dw 0000h
         jl    @end
  db 66h;add   ax,es:[di].tmode.actviewport.y1.word
  db 66h;cmp   ax,es:[di].tmode.actviewport.y2.word
         jg    @end
  db 66h;add   ax,es:[di].tmode.pageadd.word
         shl   bx,2
         mul   cx
         add   ax,bx
         adc   dx,0
         mov   si,ax
         cmp   dx,lastbank
         je    @next
         push  si
         push  dx
         call  setbank
         les   di,mode
         pop   si
 @next:  mov   es,es:[di].tmode.writeptr
  db 66h;mov   ax,col.word
  db 66h;mov   es:[si],ax
 @end:
end;

procedure ap_24_lin(x,y,col : longint;alpha : byte;var mode : tmode);assembler;
asm
         les   di,mode
  db 66h;mov   si,x.word
  db 66h;cmp   si,es:[di].tmode.actviewport.y1.word
         jl    @end
  db 66h;cmp   si,es:[di].tmode.actviewport.x2.word
         jg    @end
  db 66h;mov   cx,es:[di].tmode.bpl.word
  db 66h;mov   ax,y.word
  db 66h;cmp   ax,es:[di].tmode.actviewport.y1.word
         jl    @end
  db 66h;cmp   ax,es:[di].tmode.actviewport.y2.word
         jg    @end
  db 66h;mul   cx
  db 66h;add   ax,si
  db 66h;add   si,si
  db 66h;add   si,ax
  db 66h;add   si,es:[di].tmode.displayofs.word

  db 66h;xor   cx,cx
         mov   cl,alpha
         neg   cl
         jz    @end

         mov   es,es:[di].tmode.writeptr
         db    26h,67h,66h,8Bh,16h     { mov edx,es:[esi]   }


  db 66h;mov   bx,col.word
         mov   al,dh
  db 66h;and   dx,00FFh; dw 00FFh
         mov   ah,bh
  db 66h;and   bx,00FFh; dw 00FFh


  db 66h;sub   dx,bx
  db 66h,0Fh,0AFh,0D1h {imul edx,ecx}
  db 66h;shr   dx,8
  db 66h;add   bx,dx
  db 66h;xor   dx,dx
  db 66h;mov   dl,ah
         xor   ah,ah
         mov   bh,dl
         sub   ax,dx
         mul   cx
         add   bh,ah

         db 26h,67h,89h,1Eh {mov es:[esi],bx}
  db 66h;shr   bx,16
         db 26h,67h,88h,5Eh,02h {mov es:[esi+2],bl}


  @end:
end;

procedure ap_32_lin(x,y,col : longint;alpha : byte;var mode : tmode);assembler;
asm
         les   di,mode
  db 66h;mov   si,x.word
  db 66h;cmp   si,es:[di].tmode.actviewport.y1.word
         jl    @end
  db 66h;cmp   si,es:[di].tmode.actviewport.x2.word
         jg    @end
  db 66h;mov   cx,es:[di].tmode.bpl.word
  db 66h;mov   ax,y.word
  db 66h;cmp   ax,es:[di].tmode.actviewport.y1.word
         jl    @end
  db 66h;cmp   ax,es:[di].tmode.actviewport.y2.word
         jg    @end
  db 66h;mul   cx
  db 66h;shl   si,2
  db 66h;add   si,ax
  db 66h;add   si,es:[di].tmode.displayofs.word

  db 66h;xor   cx,cx
         mov   cl,alpha
         neg   cl
         jz    @end

         mov   es,es:[di].tmode.writeptr
         db    26h,67h,66h,8Bh,16h     { mov edx,es:[esi]   }


  db 66h;mov   bx,col.word
         mov   al,dh
  db 66h;and   dx,00FFh; dw 00FFh
         mov   ah,bh
  db 66h;and   bx,00FFh; dw 00FFh


  db 66h;sub   dx,bx
  db 66h,0Fh,0AFh,0D1h {imul edx,ecx}
  db 66h;shr   dx,8
  db 66h;add   bx,dx
  db 66h;xor   dx,dx
  db 66h;mov   dl,ah
         xor   ah,ah
         mov   bh,dl
         sub   ax,dx
         mul   cx
         add   bh,ah

         db 26h,67h,66h,89h,1Eh {mov es:[esi],ebx}

  @end:
end;

procedure ap_32_bnk(x,y,col : longint;alpha : byte;var mode : tmode);assembler;
asm
         les   di,mode
  db 66h;mov   si,x.word
  db 66h;cmp   si,0
         jl    @end
  db 66h;cmp   si,es:[di].tmode.actviewport.x2.word
         jg    @end
         mov   cx,es:[di].tmode.bpl.word
  db 66h;mov   ax,y.word
  db 66h;cmp   ax,0;dw 0000h
         jl    @end
  db 66h;cmp   ax,es:[di].tmode.actviewport.y2.word
         jg    @end
  db 66h;add   ax,es:[di].tmode.pageadd.word
         shl   si,2
         mul   cx
         add   si,ax
         adc   dx,0
         cmp   dx,lastbank
         je    @next
         push  si
         push  dx
         call  setbank
         les   di,mode
         pop   si
 @next:

  db 66h;xor   cx,cx
         mov   cl,alpha
         neg   cl
         jz    @end

         mov   es,es:[di].tmode.writeptr
  db 66h;mov   dx,es:[si]


  db 66h;mov   bx,col.word
         mov   al,dh
  db 66h;and   dx,00FFh; dw 00FFh
         mov   ah,bh
  db 66h;and   bx,00FFh; dw 00FFh


  db 66h;sub   dx,bx
  db 66h,0Fh,0AFh,0D1h {imul edx,ecx}
  db 66h;shr   dx,8
  db 66h;add   bx,dx
  db 66h;xor   dx,dx
  db 66h;mov   dl,ah
         xor   ah,ah
         mov   bh,dl
         sub   ax,dx
         mul   cx
         add   bh,ah

  db 66h;mov   es:[si],bx

  @end:
end;

function gp_32_lin(x,y : longint;var mode : tmode) : longint;assembler;
asm
         les   di,mode
  db 66h;mov   bx,x.word
  db 66h;cmp   bx,0
         jl    @end
  db 66h;add   bx,es:[di].tmode.actviewport.x1.word
  db 66h;cmp   bx,es:[di].tmode.actviewport.x2.word
         jg    @end
  db 66h;mov   cx,es:[di].tmode.bpl.word
  db 66h;mov   ax,y.word
  db 66h;cmp   ax,0;dw 0000h
         jl    @end
  db 66h;add   ax,es:[di].tmode.actviewport.y1.word
  db 66h;cmp   ax,es:[di].tmode.actviewport.y2.word
         jg    @end
  db 66h;mul   cx
  db 66h;shl   bx,2
  db 66h;add   bx,ax
  db 66h;add   bx,es:[di].tmode.displayofs.word
         mov   es,es:[di].tmode.writeptr
         db    26h,67h,66h,8Bh,03h     { mov eax,es:[ebx]   }
  db 66h;mov   dx,ax
  db 66h;shr   dx,16
         jmp   @stop
 @end:
         xor   ax,ax
         xor   dx,dx
 @stop:
end;

function gp_32_bnk(x,y : longint;var mode : tmode) : longint;assembler;
asm
         les   di,mode
  db 66h;mov   bx,x.word
  db 66h;cmp   bx,0
         jl    @end
  db 66h;add   bx,es:[di].tmode.actviewport.x1.word
  db 66h;cmp   bx,es:[di].tmode.actviewport.x2.word
         jg    @end
         mov   cx,es:[di].tmode.bpl.word
  db 66h;mov   ax,y.word
  db 66h;cmp   ax,0;dw 0000h
         jl    @end
  db 66h;add   ax,es:[di].tmode.actviewport.y1.word
  db 66h;cmp   ax,es:[di].tmode.actviewport.y2.word
         jg    @end
  db 66h;add   ax,es:[di].tmode.pageadd.word
         mul   cx
         shl   bx,2
         add   ax,bx
         adc   dx,0
         mov   si,ax
         cmp   dx,lastbank
         je    @next
         push  si
         push  dx
         call  setbank
         les   di,mode
         pop   si
 @next:  mov   es,es:[di].tmode.writeptr
         mov   ax,es:[si]
         mov   dx,es:[si+2]
         jmp   @stop
 @end:
         xor   ax,ax
         xor   dx,dx
 @stop:
end;

procedure pp_24_lin(x,y,col : longint;var mode : tmode);assembler;
asm
         les   di,mode
  db 66h;mov   bx,x.word
  db 66h;cmp   bx,0
         jl    @end
  db 66h;add   bx,es:[di].tmode.actviewport.x1.word
  db 66h;cmp   bx,es:[di].tmode.actviewport.x2.word
         jg    @end
  db 66h;mov   cx,es:[di].tmode.bpl.word
  db 66h;mov   ax,y.word
  db 66h;cmp   ax,0;dw 0000h
         jl    @end
  db 66h;add   ax,es:[di].tmode.actviewport.y1.word
  db 66h;cmp   ax,es:[di].tmode.actviewport.y2.word
         jg    @end
  db 66h;mul   cx
  db 66h;add   ax,bx
  db 66h;add   bx,bx
  db 66h;add   ax,bx
  db 66h;add   ax,es:[di].tmode.displayofs.word
         mov   es,es:[di].tmode.writeptr
         mov   bx,col.word
         db    26h,67h,89h,18h     { mov es:[eax],bx   }
         mov   bl,col.byte[2]
         db    26h,67h,88h,58h,02h { mov es:[eax+2],bl }
 @end:
end;

procedure pp_24_bnk(x,y,col : longint;var mode : tmode);assembler;
asm
         les   di,mode
  db 66h;mov   bx,x.word
  db 66h;cmp   bx,0
         jl    @end
  db 66h;add   bx,es:[di].tmode.actviewport.x1.word
  db 66h;cmp   bx,es:[di].tmode.actviewport.x2.word
         jg    @end
         mov   cx,es:[di].tmode.bpl.word
  db 66h;mov   ax,y.word
  db 66h;cmp   ax,0;dw 0000h
         jl    @end
  db 66h;add   ax,es:[di].tmode.actviewport.y1.word
  db 66h;cmp   ax,es:[di].tmode.actviewport.y2.word
         jg    @end
  db 66h;add   ax,es:[di].tmode.pageadd.word
         shl   bx,2
         mul   cx
         add   ax,bx
         adc   dx,0
         mov   si,ax
         cmp   dx,lastbank
         je    @next
         push  si
         push  dx
         call  setbank
         les   di,mode
         pop   si
 @next:  mov   es,es:[di].tmode.writeptr
         mov   di,si
         add   si,2
         jnc   @fastpixel
         mov   ax,col.word
         mov   es:[si],al
         inc   si
         jnc   @noflip1
           call   incbank
         @noflip1:
         mov   es:[si],ah
         inc   si
         jnc   @noflip2
           call   incbank
         @noflip2:
         mov   al,col.byte[2]
         mov   es:[si+1],al
         jmp   @end
 @fastpixel:
         mov   ax,col.word
         mov   es:[si],ax
         mov   al,col.byte[2]
         mov   es:[si+2],al
 @end:
end;

function gp_24_lin(x,y : longint;var mode : tmode) : longint;assembler;
asm
         les   di,mode
  db 66h;mov   bx,x.word
  db 66h;cmp   bx,0
         jl    @end
  db 66h;add   bx,es:[di].tmode.actviewport.x1.word
  db 66h;cmp   bx,es:[di].tmode.actviewport.x2.word
         jg    @end
  db 66h;mov   cx,es:[di].tmode.bpl.word
  db 66h;mov   ax,y.word
  db 66h;cmp   ax,0;dw 0000h
         jl    @end
  db 66h;add   ax,es:[di].tmode.actviewport.y1.word
  db 66h;cmp   ax,es:[di].tmode.actviewport.y2.word
         jg    @end
  db 66h;mul   cx
  db 66h;add   ax,bx
  db 66h;add   bx,bx
  db 66h;add   bx,ax
  db 66h;add   bx,es:[di].tmode.displayofs.word
         mov   es,es:[di].tmode.writeptr
         db    26h,67h,8Bh,03h     { mov ax,es:[ebx]   }
         db    26h,67h,8Ah,53h,02h { mov dl,es:[ebx+2] }
         jmp   @stop
 @end:
         xor   ax,ax
         xor   dx,dx
 @stop:
         xor   dh,dh
end;

function gp_24_bnk(x,y : longint;var mode : tmode) : longint;assembler;
asm
         les   di,mode
  db 66h;mov   bx,x.word
  db 66h;cmp   bx,0
         jl    @end
  db 66h;add   bx,es:[di].tmode.actviewport.x1.word
  db 66h;cmp   bx,es:[di].tmode.actviewport.x2.word
         jg    @end
         mov   cx,es:[di].tmode.bpl.word
  db 66h;mov   ax,y.word
  db 66h;cmp   ax,0;dw 0000h
         jl    @end
  db 66h;add   ax,es:[di].tmode.actviewport.y1.word
  db 66h;cmp   ax,es:[di].tmode.actviewport.y2.word
         jg    @end
  db 66h;add   ax,es:[di].tmode.pageadd.word
         mul   cx
         add   bx,bx
         add   ax,bx
         adc   dx,0
         mov   si,ax
         cmp   dx,lastbank
         je    @next
         push  si
         push  dx
         call  setbank
         les   di,mode
         pop   si
 @next:  mov   es,es:[di].tmode.writeptr
         mov   di,si
         add   si,2
         jnc   @fastget
         mov   al,es:[si]
         inc   si
         jnc   @noflip1
           call   incbank
         @noflip1:
         mov   ah,es:[si]
         inc   si
         jnc   @noflip2
           call   incbank
         @noflip2:
         mov   dl,es:[si]

         jmp   @stop
 @fastget:
         mov   ax,es:[si]
         mov   dl,es:[si+2]
         jmp   @stop
 @end:
         xor   ax,ax
         xor   dx,dx
 @stop:
         xor   dh,dh
end;

(*procedure fillrect_32_bnk(x1,y1,sizex,sizey,col,flags : longint;var mode : tmode);
var
  i,mempos,i3  : word;
  fill         : procedure(dest : pointer48;count : longint;data : longint);
  fillpatt     : procedure(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
begin
  sizex := sizex shl 2;
  mempos := mode.calcofs(x1,y1+mode.pageadd,mode);
  if mode.pattern[0] = 1 then begin
    fill := fill32screen;
    case flags shr 24 of
      $00 :;
      $01 : fill := subfill_32;
      $02 : fill := addfill_32;
      $04 : fill := fillxor_32;
    end;
    for i := y1 to y1+sizey do begin
      if mempos < mempos+word(sizex) then begin
        fill(ptr48(mode.writeptr,mempos),sizex,col);
        asm
          les   di,mode
          mov   ax,es:[di].tmode.bpl.word
          add   mempos,ax
          jnc   @next
            call   incbank
          @next:
        end;
      end
      else begin
        i3 := -mempos;
        fill(ptr48(mode.writeptr,mempos),i3,col);
        incbank;
        fill(ptr48(mode.writeptr,0),(sizex-i3),col);
        inc(mempos,mode.bpl);
      end;
    end
  end else begin
    fillpatt := fillpatt_32;
    case flags shr 24 of
      $00 :;
      $01 : fillpatt := pattsub_32;
      $02 : fillpatt := pattadd_32;
      $04 : fillpatt := pattxor_32;
    end;
    for i := y1 to y1+sizey do begin
      if mempos < mempos+word(sizex) then begin
        fillpatt(ptr48(mode.writeptr,mempos),sizex,col,x1,mode.pattern[i and 7+1]);
        asm
          les   di,mode
          mov   ax,es:[di].tmode.bpl.word
          add   mempos,ax
          jnc   @next
            call   incbank
          @next:
        end;
      end
      else begin
        i3 := -mempos;
        fillpatt(ptr48(mode.writeptr,mempos),i3,col,x1,mode.pattern[i and 7+1]);
        incbank;
        fillpatt(ptr48(mode.writeptr,0),sizex-i3,col,mempos-i3,mode.pattern[i and 7+1]);
        inc(mempos,mode.bpl);
      end;
    end;
  end;
end;


procedure fillrect_24_lin(x1,y1,sizex,sizey,col,flags : longint;var mode : tmode);
var
  y        : word;
  mempos   : longint;
  fill     : procedure(dest : pointer48;count : longint;data : longint);
  fillpatt : procedure(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
begin
  sizex := sizex*3;
  mempos := mode.calcofs(x1,y1,mode)+mode.displayofs;
  if mode.pattern[0] = 1 then begin
    fill := fill24screen;
    case flags shr 24 of
      $00 :;
      $01 : fill := subfill_24_386;
      $02 : fill := addfill_24_386;
      $04 : fill := fillxor_24_386;
      else exit;
    end;
    for y := y1 to y1+sizey do begin
      fill(ptr48(mode.writeptr,mempos),sizex,col);
      inc(mempos,mode.bpl);
    end;
  end else begin
    fillpatt := fillpatt_24;
    case flags shr 24 of
      $00 :;
      $01 : fillpatt := pattsub_24_386;
      $02 : fillpatt := pattadd_24_386;
      $04 : fillpatt := pattxor_24_386;
      else exit;
    end;
    for y := y1 to y1+sizey do begin
       fillpatt(ptr48(mode.writeptr,mempos),sizex,col,x1,mode.pattern[y and 7+1]);
       inc(mempos,mode.bpl);
    end;
  end;
end;

procedure fillrect_32_lin(x1,y1,sizex,sizey,col,flags : longint;var mode : tmode);
var
  y        : word;
  mempos   : longint;
  fill     : procedure(dest : pointer48;count : longint;data : longint);
  fillpatt : procedure(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
begin
  sizex := sizex shl 2;
  mempos := mode.calcofs(x1,y1,mode)+mode.displayofs;
  if mode.pattern[0] = 1 then begin
    fill := fill32screen;
    case flags shr 24 of
      $00 :;
      $01 : fill := subfill_32;
      $02 : fill := addfill_32;
      $04 : fill := fillxor_32;
    end;
    for y := y1 to y1+sizey do begin
      fill(ptr48(mode.writeptr,mempos),sizex,col);
      inc(mempos,mode.bpl);
    end;
  end else begin
    fillpatt := fillpatt_32;
    case flags shr 24 of
      $00 :;
      $01 : fillpatt := pattsub_32;
      $02 : fillpatt := pattadd_32;
      $04 : fillpatt := pattxor_32;
    end;
    for y := y1 to y1+sizey do begin
       fillpatt(ptr48(mode.writeptr,mempos),sizex,col,x1,mode.pattern[y and 7+1]);
       inc(mempos,mode.bpl);
    end;
  end;
end;*)

var
  bpl : word;

procedure line_32_bnk(x1,y1,x2,y2,col : longint;var mode : tmode);assembler;
var
  w       : word;
asm
  les   di,mode
  mov   ax,es:[di].tmode.bpl.word
  mov   bpl,ax
  mov   ax,es:[di].tmode.pageadd.word
  add   y1.word,ax
  add   y2.word,ax
  mov   si,x2.word
  sub   si,x1.word
  jns   @PutLine_2
  mov   ax,x2.word
  mov   bx,ax
  mov   ax,x1.word
  mov   x1.word,bx
  mov   x2.word,ax
  mov   ax,y2.word
  mov   bx,ax
  mov   ax,y1.word
  mov   y1.word,bx
  mov   y2.word,ax
  neg   si            { DLTX:= -DLTX }
@PutLine_2:
           mov   ax,y1.word
           mul   bpl
           mov   cx,x1.word
           shl   cx,2
           add   ax,cx
           adc   dx,0
           cmp   dx,lastbank
           je    @next
           push  ax
           push  si
           push  dx
           call  setbank
           pop   si
           pop   ax
           les   di,mode
           @next:
           mov   es,es:[di].tmode.writeptr
           mov   di,ax
           push  bp
{            CMP   writemode,0
             JNE   @PutLine_X}

             db 66h;mov   ax,col.word

             db 66h;mov   es:[di],ax
             mov   bx,y2.word
             sub   bx,y1.word
	     jns   @PutLine_8
             neg   bx
             cmp   si,bx
             jg    @PutLine_20
             mov   cx,bx
             or    cx,cx
             jz    @PutLine_0
             mov   bp,bx
             neg   bp
             add   si,si
             add   bx,bx
@PutLine_12: sub   di,bpl
             jc    @PutLine_13
@PutLine_14:    add	bp,si
		js      @PutLine_16
		sub     bp,bx
		add     di,4
		JC      @PutLine_15
@PutLine_16:    db 66h;mov     es:[di],ax
		dec     cx
		jnz     @PutLine_12
		jmp     @PutLine_0
@PutLine_13:	call    DecBank
		jmp     @PutLine_14
@PutLine_15:	call    IncBank
		jmp     @PutLine_16
@PutLine_20:	mov     cx,si
		jcxz    @PutLine_0
		mov     bp,si
		neg     bp
		add     si,si
		add     bx,bx
@PutLine_22:    add     di,4
		jc      @PutLine_23
@PutLine_24:    add     bp,bx
		js      @PutLine_26
		sub     bp,si
		sub     di,bpl
		jc      @PutLine_25
@PutLine_26:    db 66h;mov     es:[di],ax
		dec     cx
		jnz     @PutLine_22
@PutLine_0:     POP     bp
                jmp     @END
@PutLine_23:	call    IncBank
		jmp     @PutLine_24
@PutLine_25:	call    DecBank
		jmp     @PutLine_26
@PutLine_8:	CMP     si,bx
		JG      @PutLine_40
		mov     cx,bx
		JcxZ    @PutLine_0
		mov     bp,bx
		neg     bp
		add     si,si
		add     bx,bx
@PutLine_32:    add     di,bpl
		JC      @PutLine_33
@PutLine_34:    add     bp,si
		JS      @PutLine_36
		sub     bp,bx
		add     di,4
		JC      @PutLine_35
@PutLine_36:    db 66h;mov     es:[di],ax
		DEC     cx
		JNZ     @PutLine_32
		jmp     @PutLine_0
@PutLine_33:	call    IncBank
		jmp     @PutLine_34
@PutLine_35:	call    IncBank
		jmp     @PutLine_36
@PutLine_40:	mov     cx,si
		JcxZ    @PutLine_0
		mov     bp,si
		neg     bp
		add     si,si
		add     bx,bx
@PutLine_42:    add     di,4
		JC      @PutLine_43
@PutLine_44:    add     bp,bx
		JS      @PutLine_46
		sub     bp,si
		add     di,bpl
		JC      @PutLine_45
@PutLine_46:    db 66h;mov     es:[di],ax
		DEC     cx
		JNZ     @PutLine_42
		jmp     @PutLine_0
@PutLine_43:	call    IncBank
		jmp     @PutLine_44
@PutLine_45:	call    IncBank
		jmp     @PutLine_46
@PutLine_X:     db 66h;mov     ax,col.word
                db 66h;xor     es:[di],ax
                mov     bx,Y2.word
		sub     bx,Y1.word
		JNS     @PutLinX_8
		neg     bx
                CMP     si,bx
		JG      @PutLinX_20
		mov     cx,bx
		JcxZ    @PutLinX_0
                mov     bp,bx
		neg     bp
		add     si,si
		add     bx,bx
@PutLinX_12:    sub     di,bpl
		JC      @PutLinX_13
@PutLinX_14:    add     bp,si
		JS      @PutLinX_16
		sub     bp,bx
		add     di,4
		JC      @PutLinX_15
@PutLinX_16:    db 66h;xor     es:[di],ax
		DEC     cx
		JNZ     @PutLinX_12
		jmp     @PutLinX_0
@PutLinX_13:	call    DecBank
		jmp     @PutLinX_14
@PutLinX_15:	call    IncBank
		jmp     @PutLinX_16
@PutLinX_20:	mov     cx,si
		JcxZ    @PutLinX_0
                mov     bp,si
		neg     bp
		add     si,si
		add     bx,bx
@PutLinX_22:    add     di,4
		JC      @PutLinX_23
@PutLinX_24:    add     bp,bx
		JS      @PutLinX_26
		sub     bp,si
		sub     di,bpl
		JC      @PutLinX_25
@PutLinX_26:    db 66h;xor     es:[di],ax
		DEC     cx
		JNZ     @PutLinX_22
@PutLinX_0:     jmp     @PutLine_0
@PutLinX_23:	call    IncBank
		jmp     @PutLinX_24
@PutLinX_25:	call    DecBank
		jmp     @PutLinX_26
@PutLinX_8:	CMP     si,bx
		JG      @PutLinX_40
		mov     cx,bx
		JcxZ    @PutLinX_0
                mov     bp,bx
		neg     bp
		add     si,si
		add     bx,bx
@PutLinX_32:    add     di,bpl
		JC      @PutLinX_33
@PutLinX_34:    add     bp,si
		JS      @PutLinX_36
		sub     bp,bx
		add     di,4
		JC      @PutLinX_35
@PutLinX_36:    db 66h;xor     es:[di],ax
		DEC     cx
		JNZ     @PutLinX_32
		jmp     @PutLinX_0
@PutLinX_33:	call    IncBank
		jmp     @PutLinX_34
@PutLinX_35:	call    IncBank
		jmp     @PutLinX_36
@PutLinX_40:	mov     cx,si
		JcxZ    @PutLinX_0
                mov     bp,si
		neg     bp
		add     si,si
		add     bx,bx
@PutLinX_42:    add     di,4
		JC      @PutLinX_43
@PutLinX_44:    add     bp,bx
		JS      @PutLinX_46
		sub     bp,si
		add     di,bpl
		JC      @PutLinX_45
@PutLinX_46:    db 66h;xor     es:[di],ax
		dec     cx
		jnz     @PutLinX_42
		jmp     @PutLinX_0
@PutLinX_43:	call    IncBank
		jmp     @PutLinX_44
@PutLinX_45:	call    IncBank
		jmp     @PutLinX_46
@end:
end;

procedure line_24_lin(x1,y1,x2,y2,col : longint;var mode : tmode);assembler;
var
  d,aincr,bincr : longint;
  xincr,yincr   : longint;
asm
db 66h; mov   ax,x1.word
db 66h; mov   bx,x2.word
db 66h; mov   cx,y1.word
db 66h; mov   dx,y2.word

db 66h; mov   si,bx
db 66h; sub   si,ax
        jns   @nots_x
db 66h; neg   si
        @nots_x:

db 66h; mov   di,dx
db 66h; sub   di,cx
        jns   @nots_y
db 66h; neg   di
        @nots_y:

db 66h; cmp   si,di
        jnb   @start2
db 66h; cmp   cx,dx
        jna   @noswapy
        mov   si,ax
        mov   ax,bx
        mov   bx,si

        mov   si,cx
        mov   cx,dx
        mov   dx,si

        @noswapy:

db 66h; mov   si,3; dw 0000h
db 66h; mov   di,bx
db 66h; sub   di,ax
        jns   @nots
db 66h; neg   di
db 66h; neg   si
        @nots:

db 66h; mov   xincr.word,si
db 66h; mov   si,dx
db 66h; sub   si,cx
        jz    @endofproc
db 66h; mov   bx,di
db 66h; shl   bx,1
db 66h; mov   bincr.word,bx
db 66h; sub   bx,si
db 66h; mov   d.word,bx
db 66h; sub   di,si
db 66h; sal   di,1
db 66h; mov   aincr.word,di

        les   di,mode
db 66h; mov   bx,ax
db 66h; mov   ax,es:[di].tmode.bpl.word
db 66h; mov   yincr.word,ax
db 66h; mul   cx
db 66h; mov   cx,bx
db 66h; add   bx,bx
db 66h; add   ax,cx
db 66h; add   ax,bx
db 66h; add   ax,es:[di].tmode.displayofs.word
db 66h; mov   bx,es:[di].tmode.linestyle.word
db 66h; cmp   bx,lnsdefault.word
        jne   @lnstyl_1

        mov   es,es:[di].tmode.writeptr
db 66h; mov   di,ax


db 66h; mov   bx,bincr.word
db 66h; mov   cx,si
db 66h; mov   dx,d.word

        mov   si,col.word
        mov   al,col.byte[2]
        db    26h,67h,89h,37h {mov es:[edi],si}
        db    26h,67h,88h,47h,02h {mov es:[edi+2],al}

  @lp:
        db 66h; cmp   dx,0
                jl    @next
        db 66h; add   di,xincr.word
        db 66h; add   dx,aincr.word
                jmp   @stop
  @next:db 66h; add   dx,bx
  @stop:db 66h; add   di,yincr.word
        db 26h, 67h,89h,37h {mov es:[edi],si}
        db 26h, 67h,88h,47h,02h {mov es:[edi+2],al}
        db 66h; dec   cx
        jnz   @lp
        jmp   @endofproc

@lnstyl_1:

        mov   es,es:[di].tmode.writeptr
db 66h; mov   di,ax
db 66h; mov   cx,si
db 66h; mov   dx,d.word

        mov   si,col.word
        mov   al,col.byte[2]
db 66h; test  bx,1;dw 0000h
        jz    @nofirstls1
        db    26h,67h,89h,37h {mov es:[edi],si}
        db    26h,67h,88h,47h,02h {mov es:[edi+2],al}
        @nofirstls1:

  @lpls1:
           db 66h; ror   bx,1
           db 66h; cmp   dx,0
                   jl    @nextls1
           db 66h; add   di,xincr.word
           db 66h; add   dx,aincr.word
                   jmp   @stopls1
  @nextls1:db 66h; add   dx,bincr.word
  @stopls1:db 66h; add   di,yincr.word
           db 66h; test  bx,1;dw 0000h
                   jz    @noputls1
           db 26h, 67h,89h,37h {mov es:[edi],si}
           db 26h, 67h,88h,47h,02h {mov es:[edi+2],al}
  @noputls1:
           db 66h; dec   cx
           jnz   @lpls1
           jmp   @endofproc

@start2:
db 66h; cmp   ax,bx
        jna   @noswapx
        mov   si,ax
        mov   ax,bx
        mov   bx,si

        mov   si,cx
        mov   cx,dx
        mov   dx,si

        @noswapx:

        les   di,mode
db 66h; mov   si,es:[di].tmode.bpl.word
db 66h; mov   di,dx
db 66h; sub   di,cx
        jns   @nots2
db 66h; neg   di
db 66h; neg   si
        @nots2:

db 66h; mov   yincr.word,si
db 66h; mov   si,bx
db 66h; sub   si,ax
        jz    @endofproc
db 66h; mov   bx,di
db 66h; shl   bx,1
db 66h; mov   bincr.word,bx
db 66h; sub   bx,si
db 66h; mov   d.word,bx
db 66h; sub   di,si
db 66h; sal   di,1
db 66h; mov   aincr.word,di

        les   di,mode
db 66h; mov   bx,ax
db 66h; mov   ax,es:[di].tmode.bpl.word
db 66h; mul   cx
db 66h; mov   cx,bx
db 66h; add   bx,bx
db 66h; add   ax,cx
db 66h; add   ax,bx
db 66h; add   ax,es:[di].tmode.displayofs.word
db 66h; mov   bx,es:[di].tmode.linestyle.word
db 66h; cmp   bx,lnsdefault.word
        jne   @lnstyl_2

        mov   es,es:[di].tmode.writeptr
db 66h; mov   di,ax
        mov   si,col.word
        mov   al,col.byte[2]
        db    26h,67h,89h,37h {mov es:[edi],si}
        db    26h,67h,88h,47h,02h {mov es:[edi+2],al}
db 66h; mov   bx,bincr.word
db 66h; mov   cx,aincr.word
db 66h; mov   dx,d.word
  @lp2:  db 66h; cmp   dx,0
                 jl    @next2
         db 66h; add   di,yincr.word
         db 66h; add   dx,aincr.word
                 jmp   @stop2
  @next2:db 66h; add   dx,bx
  @stop2:db 66h; add   di,3
         db 26h, 67h,89h,37h {mov es:[edi],si}
         db 26h, 67h,88h,47h,02h {mov es:[edi+2],al}
         db 66h; dec   cx
         jnz   @lp2
        jmp   @endofproc

@lnstyl_2:

        mov   es,es:[di].tmode.writeptr
db 66h; mov   di,ax
db 66h; mov   cx,si
db 66h; mov   dx,d.word
db 66h; mov   si,aincr.word

        mov   si,col.word
        mov   al,col.byte[2]
db 66h; test  bx,1;dw 0000h
        jz    @nofirstls2
        db    26h,67h,89h,37h {mov es:[edi],si}
        db    26h,67h,88h,47h,02h {mov es:[edi+2],al}
        @nofirstls2:

  @lpls2:  db 66h; ror   bx,1
           db 66h; cmp   dx,0
                   jl    @nextls2
           db 66h; add   di,yincr.word
           db 66h; add   dx,aincr.word
                   jmp   @stopls2
  @nextls2:db 66h; add   dx,bincr.word
  @stopls2:db 66h; add   di,3
           db 66h; test  bx,1;dw 0000h
                   jz    @noputls2
           db 26h, 67h,89h,37h {mov es:[edi],si}
           db 26h, 67h,88h,47h,02h {mov es:[edi+2],al}
  @noputls2:
           db 66h; dec   cx
                   jnz   @lpls2

@endofproc:
end;

procedure line_32_lin(x1,y1,x2,y2,col : longint;var mode : tmode);assembler;
var
  d,aincr,bincr : longint;
  xincr,yincr   : longint;
asm
db 66h; mov   ax,x1.word
db 66h; mov   bx,x2.word
db 66h; mov   cx,y1.word
db 66h; mov   dx,y2.word

db 66h; mov   si,bx
db 66h; sub   si,ax
        jns   @nots_x
db 66h; neg   si
        @nots_x:

db 66h; mov   di,dx
db 66h; sub   di,cx
        jns   @nots_y
db 66h; neg   di
        @nots_y:

db 66h; cmp   si,di
        jnb   @start2
db 66h; cmp   cx,dx
        jna   @noswapy
db 66h; mov   si,ax
db 66h; mov   ax,bx
db 66h; mov   bx,si

db 66h; mov   si,cx
db 66h; mov   cx,dx
db 66h; mov   dx,si

        @noswapy:

db 66h; mov   si,4; dw 0000h
db 66h; mov   di,bx
db 66h; sub   di,ax
        jns   @nots
db 66h; neg   di
db 66h; neg   si
        @nots:

db 66h; mov   xincr.word,si
db 66h; mov   si,dx
db 66h; sub   si,cx
        jz    @endofproc
db 66h; mov   bx,di
db 66h; shl   bx,1
db 66h; mov   bincr.word,bx
db 66h; sub   bx,si
db 66h; mov   d.word,bx
db 66h; sub   di,si
db 66h; sal   di,1
db 66h; mov   aincr.word,di

        les   di,mode
db 66h; mov   bx,ax
db 66h; mov   ax,es:[di].tmode.bpl.word
db 66h; mov   yincr.word,ax
db 66h; mul   cx
db 66h; shl   bx,2
db 66h; add   ax,bx
db 66h; add   ax,es:[di].tmode.displayofs.word
db 66h; mov   bx,es:[di].tmode.linestyle.word
db 66h; cmp   bx,lnsdefault.word
        jne   @lnstyl_1

        mov   es,es:[di].tmode.writeptr
db 66h; mov   di,ax
db 66h; mov   ax,col.word
        db    26h,67h,66h,89h,07h {mov es:[edi],eax}
db 66h; mov   bx,bincr.word
db 66h; mov   cx,si
db 66h; mov   dx,d.word
db 66h; mov   si,aincr.word
  @lp:
        db 66h; cmp   dx,0
                jl    @next
        db 66h; add   di,xincr.word
        db 66h; add   dx,si
                jmp   @stop
  @next:db 66h; add   dx,bx
  @stop:db 66h; add   di,yincr.word
        db 26h, 67h,66h,89h,07h {mov es:[edi],eax}
        db 66h; dec   cx
        jnz   @lp
        jmp   @endofproc

@lnstyl_1:

        mov   es,es:[di].tmode.writeptr
db 66h; mov   di,ax
db 66h; mov   ax,col.word
db 66h; test  bx,1;dw 0000h
        jz    @nofirstls1
        db    26h,67h,66h,89h,07h {mov es:[edi],eax}
        @nofirstls1:
db 66h; mov   cx,si
db 66h; mov   dx,d.word
db 66h; mov   si,aincr.word
  @lpls1:
           db 66h; ror   bx,1
           db 66h; cmp   dx,0
                   jl    @nextls1
           db 66h; add   di,xincr.word
           db 66h; add   dx,si
                   jmp   @stopls1
  @nextls1:db 66h; add   dx,bincr.word
  @stopls1:db 66h; add   di,yincr.word
           db 66h; test  bx,1;dw 0000h
                   jz    @noputls1
           db 26h, 67h,66h,89h,07h {mov es:[edi],eax}
  @noputls1:
           db 66h; dec   cx
           jnz   @lpls1
           jmp   @endofproc

@start2:
db 66h; cmp   ax,bx
        jna   @noswapx
        mov   si,ax
        mov   ax,bx
        mov   bx,si

        mov   si,cx
        mov   cx,dx
        mov   dx,si

        @noswapx:

        les   di,mode
db 66h; mov   si,es:[di].tmode.bpl.word
db 66h; mov   di,dx
db 66h; sub   di,cx
        jns   @nots2
db 66h; neg   di
db 66h; neg   si
        @nots2:

db 66h; mov   yincr.word,si
db 66h; mov   si,bx
db 66h; sub   si,ax
        jz    @endofproc
db 66h; mov   bx,di
db 66h; shl   bx,1
db 66h; mov   bincr.word,bx
db 66h; sub   bx,si
db 66h; mov   d.word,bx
db 66h; sub   di,si
db 66h; sal   di,1
db 66h; mov   aincr.word,di

        les   di,mode
db 66h; mov   bx,ax
db 66h; mov   ax,es:[di].tmode.bpl.word
db 66h; mul   cx
db 66h; shl   bx,2
db 66h; add   ax,bx
db 66h; add   ax,es:[di].tmode.displayofs.word
db 66h; mov   bx,es:[di].tmode.linestyle.word
db 66h; cmp   bx,lnsdefault.word
        jne   @lnstyl_2

        mov   es,es:[di].tmode.writeptr
db 66h; mov   di,ax
db 66h; mov   ax,col.word
        db    26h,67h,66h,89h,07h {mov es:[edi],eax}
db 66h; mov   bx,bincr.word
db 66h; mov   cx,si
db 66h; mov   dx,d.word
db 66h; mov   si,aincr.word
db 66h; push  bp
        db    66h;mov  bp,yincr.word
  @lp2:  db 66h; cmp   dx,0
                 jl    @next2
         db 66h; add   di,bp
         db 66h; add   dx,si
                 jmp   @stop2
  @next2:db 66h; add   dx,bx
  @stop2:db 66h; add   di,4
         db 26h, 67h,66h,89h,07h {mov es:[edi],eax}
        db 66h; dec   cx
        jnz   @lp2
db 66h; pop   bp
        jmp   @endofproc

@lnstyl_2:

        mov   es,es:[di].tmode.writeptr
db 66h; mov   di,ax
db 66h; mov   ax,col.word
db 66h; test  bx,1;dw 0000h
        jz    @nofirstls2
        db    26h,67h,66h,89h,07h {mov es:[edi],eax}
        @nofirstls2:
db 66h; mov   cx,si
db 66h; mov   dx,d.word
db 66h; mov   si,aincr.word

  @lpls2:  db 66h; ror   bx,1
           db 66h; cmp   dx,0
                   jl    @nextls2
           db 66h; add   di,yincr.word
           db 66h; add   dx,si
                   jmp   @stopls2
  @nextls2:db 66h; add   dx,bincr.word
  @stopls2:db 66h; add   di,4
           db 66h; test  bx,1;dw 0000h
                   jz    @noputls2
           db 26h, 67h,66h,89h,07h {mov es:[edi],eax}
  @noputls2:
           db 66h; dec   cx
                   jnz   @lpls2

@endofproc:
end;

function calcofs_32_lin(x,y : integer;var mode): longint;assembler;
asm
  les   di,mode
  mov   bx,x
  mov   cx,word ptr es:[di].tmode.bpl
  shl   bx,2
  mov   ax,y
  mul   cx
  add   ax,bx
  adc   dx,0
end;

function calcofs_32_bnk(x,y : integer;var mode) : longint;assembler;
asm
  les   di,mode
  mov   bx,x
  shl   bx,2
  mov   cx,word ptr es:[di].tmode.bpl
  mov   ax,y
  mul   cx
  add   ax,bx
  adc   dx,0
  mov   si,ax
  cmp   dx,lastbank
  je    @end
  push  dx
  call  setbank
@end:
  mov   ax,si
  xor   dx,dx
end;

function calcofs_24_lin(x,y : integer;var mode): longint;assembler;
asm
  les   di,mode
  mov   bx,x
  mov   cx,word ptr es:[di].tmode.bpl
  mov   ax,bx
  add   bx,bx
  add   bx,ax
  mov   ax,y
  mul   cx
  add   ax,bx
  adc   dx,0
end;

function calcofs_24_bnk(x,y : integer;var mode) : longint;assembler;
asm
  les   di,mode
  mov   bx,x
  mov   ax,bx
  add   bx,bx
  add   bx,ax
  mov   cx,word ptr es:[di].tmode.bpl
  mov   ax,y
  mul   cx
  add   ax,bx
  adc   dx,0
  mov   si,ax
  cmp   dx,lastbank
  je    @end
  push  dx
  call  setbank
@end:
  mov   ax,si
  xor   dx,dx
end;

begin
end.