{$R-}
uses grafx2,gx_glob,crt,timebase,pnglib,newfrontier,gx_fx,gx_col,stream32,gx_font;
const
  dpos  : tpoint=(x:20;y:20);
  dsize : tpoint=(x:320;y:240);

var
  screen               : tgxscreen;
  memimg,memimg2,tw    : timage;
  vscreen              : tgxmem;
  image1,image2,image3 : timage;
  textwin              : tgxmem;
  im1,im2,im3          : timage;
  timer                : tztimer;
  s                    : tfilestream32;
  font                 : tttf;

procedure doexit;
var
  i : integer;
begin
  timer.done;
  check4fail(closeimage(image1));
  check4fail(closeimage(image2));
  check4fail(closeimage(image3));
  check4fail(closeimage(im1));
  check4fail(closeimage(im2));
  check4fail(closeimage(im3));
  screen.get(0,0,screen.maxx,screen.maxy,image1);
  for i := 0 to 31 do begin
    fadeout_image(image1,8);
    screen.draw(0,0,image1,drdefault);
  end;
  screen.close;
  while keypressed do readkey;
  halt;
  font.close;
end;

function checkbuttons : boolean;
var
  c : char;
begin
  checkbuttons := false;
  while keypressed do begin
    c := readkey;
    if c in [#13,#27] then checkbuttons := true;
    if c = #27 then doexit;
  end;
end;

procedure runadd;
var
  i : integer;

begin
  check4fail(openimage(memimg,320,240,screen.mode.bpp,0,imdefault));
  if not vscreen.init(memimg) then exit;
  check4fail(convertimage(image1,im1,screen.mode.bpp));
  vscreen.draw(0,0,im1,drdefault);
  i := 320;
  repeat
    dec(i,4);
    vscreen.draw(0,0,im1,drdefault);
    vscreen.fillrect(320,0,639,239,black,filldefault);
    vscreen.draw(round(320-cos(i/160)*320),0,image3,dradd);
    waitretrace;
    screen.draw(dpos.x,dpos.y,memimg,drdefault);
  until (i = 0)or(checkbuttons);
  check4fail(closeimage(im1));
  vscreen.close;
  check4fail(closeimage(memimg));
end;

procedure runxfade;
var
  i     : integer;
  up    : boolean;
  value : word;
  bpp   : word;
begin
  if screen.mode.bpp = 24 then bpp := 24 else bpp := 32;
  convertimage(image1,im1,bpp);
  convertimage(image2,im2,bpp);
  up := true;
  i  := 0;
  repeat
    value := (i shl 2)-1;
    if i = 0 then value := 0;
    check4fail(blend(im1,im2,im3,value));
    screen.draw(dpos.x,dpos.y,im3,drdefault);
    if up then inc(i) else dec(i);
    if (i = 0)or(i = 64) then up := not up;
  until (checkbuttons);
  check4fail(closeimage(im1));
  check4fail(closeimage(im2));
  check4fail(closeimage(im3));
end;

procedure runblocking;
var
  i                 : integer;
  dcrval            : integer;
  bpp               : word;

begin
  if screen.mode.bpp = 24 then bpp := 24 else bpp := 32;
  { First we load the images... }
  check4fail(convertimage(image1,im1,bpp));
  check4fail(duplicateimage(im1,im2));
  i := image1.sizex shr 2;
  { Now the blocking effect... }
  repeat
    dec(i);
    blockout(im1,im2,i shl 1,i shl 1);
    brightness_image(im2,im2,255-round(i/(im1.sizex/4)*255));
    waitretrace;
    screen.draw(dpos.x,dpos.y,im2,drdefault);
  until (i <= 0)or(checkbuttons);
  screen.draw(dpos.x,dpos.y,im1,drdefault);
  check4fail(closeimage(im1));
  check4fail(closeimage(im2));
  { Load the grafx2-text... }
  if not s.init('images\text.png',stopenread) then writeln(gxerror,'images\text.png not found');
  check4fail(loadpng(s,im1,32,lddefault));
  check4fail(duplicateimage(im1,im2));
  check4fail(openimage(memimg,im1.sizex,im1.sizey,screen.mode.bpp,0,imdefault));
  screen.get(dpos.x+10,dpos.y+95,dpos.x+10+im1.sizex-1,dpos.y+95+im1.sizey-1,im3);
  if not vscreen.init(memimg) then exit;
  i := im1.sizex shr 3;
  { Show that text with similar effect, but with alphamapping... }
  repeat
    dec(i);
    blockout(im1,im2,i,i);
    brightness_alpha(im2,255-round(i/(im1.sizex/8)*255));
    vscreen.draw(0,0,im3,drdefault);
    vscreen.draw(0,0,im2,drdefault);
    timer.delay(25);
    screen.draw(dpos.x+10,dpos.y+95,memimg,drdefault);
  until (i = 0)or(checkbuttons);
  vscreen.close;
  check4fail(closeimage(im1));
  check4fail(closeimage(im2));
  check4fail(closeimage(im3));
  check4fail(closeimage(memimg));
end;

{Just in case you wanna see what antialiasing means: enable this
 piece and comment out the other runrotate - it's damn slow but
 it looks also damn good! Not useable for realtime calculations,
 but at least for imaging programs.
 MMX strongly recommended - speeds up by at least 30%}

(*procedure runrotate;
var
  degrees : word;
  hsi     : timage;
begin
  doublesize_image(image1,im1);
  doublesize_image(image2,im2);
  duplicateimage(im2,im3);
  degrees := 0;
  repeat
    degrees := (degrees+1) mod 360;
    flipimage(im1,im3);
    check4fail(rotate_image(im2,im3,degrees,$FFFFFFFF));
    halfsize_image(im3,hsi);
    screen.draw(dpos.x,dpos.y,hsi,drdefault);
  until (checkbuttons);
  check4fail(closeimage(im1));
  check4fail(closeimage(im2));
  check4fail(closeimage(im3));
  check4fail(closeimage(hsi));
end;*)

procedure runrotate;
var
  degrees : word;
begin
  check4fail(convertimage(image1,im1,screen.mode.bpp));
  check4fail(convertimage(image2,im2,screen.mode.bpp));
  duplicateimage(im2,im3);
  degrees := 0;
  repeat
    degrees := (degrees+1) mod 360;
    flipimage(im1,im3);
    check4fail(rotate_image(im2,im3,degrees,$FFFFFFFF));
    screen.draw(dpos.x,dpos.y,im3,drdefault);
  until (checkbuttons);
  check4fail(closeimage(im1));
  check4fail(closeimage(im2));
  check4fail(closeimage(im3));
end;

var
  p      : pointer48;
procedure runscaleup;
var
  image2 : timage;
  i,i2   : integer;
  gx2    : timage;

{procedure quadpixel(x,y,col : longint);assembler;
asm
  db 66h;les   di,p.dword
  db 66h;mov   cx,memimg.bpl.word
  db 66h;mov   bx,x.word
  db 66h;mov   ax,y.word
  db 66h;shl   bx,2
  db 66h;mul   cx
  db 66h;add   bx,ax
  db 66h;mov   ax,col.word
  db 66h;add   di,bx
  db 66h;sub   cx,8
  db 67h,66h,0ABh
  db 67h,66h,0ABh
  db 66h;add   di,cx
  db 67h,66h,0ABh
  db 67h,66h,0ABh
end;}

begin
  openimage(memimg,320,240,32,0,imdefault);
  duplicateimage(memimg,image2);
  if not vscreen.init(memimg) then exit;
  if not s.init('images\gx2spr.png',stopenread) then writeln(gxerror,'images\gx2spr.png not found');
  check4fail(loadpng(s,gx2,memimg.bpp,lddefault));
  p := ptr48(memimg.data,memimg.imagestart);
  i2 := 0;
  repeat
    for i := 0 to 119 do
    vscreen.putpixel(random(vscreen.maxx-4)+2,random(vscreen.maxy-4)+2,
    vscreen.rgb(0,255,200));
{    quadpixel(random(vscreen.maxx-4)+2,random(vscreen.maxy-4)+2,
    random(65535)+longint(random(255)) shl 16);}
{    quadpixel(random(vscreen.maxx-4)+2,random(vscreen.maxy-4)+2,
    vscreen.rgb(255,255,0));}
{    vscreen.draw(round(sin(2*pi*i2/255)*80+(memimg.sizex-gx2.sizex)/2),
                 round(cos(2*pi*i2/255)*35+(memimg.sizey-gx2.sizey)/2),
                 gx2,drdefault);}
     if random(128) = 64 then
     vscreen.draw((memimg.sizex-gx2.sizex) shr 1,(memimg.sizey-gx2.sizey) shr 1,
                  gx2,drdefault);
    i2 := (i2+2) and $FF;
    blur_image(memimg);
    flipimage(memimg,image2);
    screen.draw(dpos.x,dpos.y,image2,drdefault);
    scaleup_image(image2,memimg,7,7);
  until checkbuttons;
  vscreen.close;
  closeimage(memimg);
end;

procedure showscreen;
var
  x,y  : word;
  drvinfo : tdrvinfo;
begin
  if not s.init('images\bg2.png',stopenread) then writeln(gxerror,'images\bg2.png not found');
  check4fail(loadpng(s,image1,screen.mode.bpp,lddefault));
  for y := 0 to round(screen.mode.resx/image1.sizey)-1 do
  for x := 0 to round(screen.mode.resx/image1.sizex)-1 do
  screen.draw(x*image1.sizex,y*image1.sizey,image1,drdefault);
  check4fail(closeimage(image1));
  screen.setpattern(pthatch);
  screen.fillrect(dpos.x-10,dpos.y-10,dpos.x+dsize.x+10,dpos.y+dsize.y+10,
              screen.gray(127),fillsub);
  screen.setpattern(ptdefault);
  screen.fillrect(dpos.x-10,dpos.y+dsize.y+20,dpos.x+dsize.x+10,dpos.y+dsize.y+210,
              screen.gray(100),fillsub);
  screen.fillrect(dpos.x,dpos.y,dpos.x+dsize.x-1,dpos.y+dsize.y-1,
              black,filldefault);
  screen.get(dpos.x,dpos.y+dsize.y+30,dpos.x+dsize.x,dpos.y+dsize.y+210,memimg2);
  check4fail(duplicateimage(memimg2,tw));
  textwin.init(memimg2);

  font.setfontattributes(textdefault,textdefault,textsub);
  font.write(screen,dpos.x+dsize.x+30,dpos.y+50,screen.getversionstring,screen.gray(127));
  font.write(screen,dpos.x+dsize.x+30,dpos.y+70,'A short show of some abilities',screen.gray(127));
  font.write(screen,dpos.x+dsize.x+30,dpos.y+80,'GrafX2 does provide. Note that',screen.gray(127));
  font.write(screen,dpos.x+dsize.x+30,dpos.y+90,'this is only a small amount of',screen.gray(127));
  font.write(screen,dpos.x+dsize.x+30,dpos.y+100,'all available features.',screen.gray(127));
  getcurrentdriverinfo(drvinfo);
  font.write(screen,dpos.x+dsize.x+30,dpos.y+120,'Card...: '+drvinfo.producer+' '+drvinfo.name,screen.gray(127));
  font.write(screen,dpos.x+dsize.x+30,dpos.y+130,'Memory.: '+inttostr(drvinfo.memory shr 10)+' KB',screen.gray(127));
  font.write(screen,dpos.x+dsize.x+30,dpos.y+140,'Driver.: '+drvinfo.drvname,screen.gray(127));
  font.write(screen,dpos.x+dsize.x+30,dpos.y+150,'By.....: '+drvinfo.drvprod,screen.gray(127));
  font.write(screen,dpos.x+dsize.x+30,dpos.y+160,'Version: '+drvinfo.drvversionstr,screen.gray(127));

  font.write(screen,dpos.x+dsize.x+30,dpos.y+200,'Available memory: '+inttostr(memavail32 shr 10)+' KB',screen.gray(127));

  if not s.init('images\gx2-250.png',stopenread) then writeln(gxerror,'images\gx2-250.png not found');
  check4fail(loadpng(s,image1,0,ldauto));
  screen.draw(dpos.x+dsize.x+25,dpos.y-5,image1,drdefault);
  check4fail(closeimage(image1));
end;


const
  textbufsize = 17;
var
  textbuf   : array[0..textbufsize-1] of string[80];
  bufpos    : word;
  fullspeed : boolean;

procedure showtext(s : string);
var
  i,y,x : integer;
  color : longint;
begin
  font.setfontattributes(textdefault,textdefault,textadd);
  color := textwin.gray(127);
  move(textbuf[1],textbuf[0],sizeof(textbuf)-sizeof(textbuf[0]));
  textbuf[textbufsize-1] := s;
  if not fullspeed then begin
    for y := 9 downto 0 do begin
      textwin.draw(0,0,tw,drdefault);
      for i := 0 to textbufsize-2 do
      font.write(textwin,0,i*10+y,textbuf[i],color);
      waitretrace;
      screen.draw(dpos.x,dpos.y+dsize.y+30,memimg2,drdefault);
    end;
    color := screen.gray(255);
    x := 0;
    for i := 1 to length(s) do begin
      if not fullspeed then timer.delay(45);
      font.write(screen,dpos.x+x,dpos.y+dsize.y+20+textbufsize*10,s[i],color);
      inc(x,font.width(s[i])+1);
      if checkbuttons then fullspeed := true;
    end;
  end else begin
    textwin.draw(0,0,tw,drdefault);
    for i := 0 to textbufsize-1 do
    font.write(textwin,0,i*10,textbuf[i],color);
    screen.draw(dpos.x,dpos.y+dsize.y+30,memimg2,drdefault);
    checkbuttons;
  end;
  font.setfontattributes(textdefault,textdefault,textdefault);
end;

var
  startres : word;

procedure resmenu;
var
  ch     : char;
  dither : boolean;
begin
  writeln('*** Color resolution menu ***');
  writeln('Note: dithering slows down the 32 to 15/16 conversion by about 50%,');
  writeln('but looks partially alot better, especially in 15 bpp mode');
  writeln('WARNING! Your card may NOT support all color resolutions presented');
  writeln('below. The sooncoming new demo will check this automatically.');
  writeln('[1] 15 bpp');
  writeln('[2] 15 bpp + dithering');
  writeln('[3] 16 bpp');
  writeln('[4] 16 bpp + dithering');
  writeln('[5] 32 bpp');
  writeln('[6] 24 bpp (Linear only)');
  dither := false;
  repeat
    ch := readkey;
    case ch of
      '1'     : startres := 15;
      '2'     : begin;startres := 15;dither := true;end;
      '3',#13 : startres := 16;
      '4'     : begin;startres := 16;dither := true;end;
      '5'     : startres := 32;
      '6'     : startres := 24;
    end;
  until (ch in ['1'..'6',#27,#13]);
  if ch = #27 then halt;
  if dither then begin
    cnvdrwmd := cnvdither;
    cnvimgmd := cnvdither;
    cnvvidmd := cnvdither;
  end;
end;

begin
  clrscr;
  writeln('GrafX2 Demo ver 0.39');
  writeln;
  writeln('I hope you have a relatively fast machine - although the');
  writeln('routines are very fast, a 150 Mhz MMX CPU is recommended.');
  writeln('Vesa 2 or better recommended - it''s simply faster ;)');
  writeln('Please note that this demo is only for first testal purposes');
  writeln('and does not really do any sophisticated error-detection.');
  writeln;
  writeln('Detected CPU extensions:');
  if cpuext and cpummx <> 0 then begin
    write('MMX');
    if cpuext and cpu3dn <> 0 then writeln(', 3DNow!') else writeln;
  end else writeln('none');
  writeln;
  resmenu;
  if not screen.init(640,480,startres,mdauto) then
   writeln(gxerror,'Error while initializing video mode');
  timer.init;
  fillchar(textbuf,sizeof(textbuf),0);
  font.init('gx2fonts\verdanab.ttf');
  showscreen;
  fullspeed := true;
  showtext('Please wait while loading images...');
  showtext('.fade1.png');
  if not s.init('images\fade1.png',stopenread) then writeln(gxerror,'images\fade1.png not found');
  check4fail(loadpng(s,image1,32,lddefault));
  showtext('.fade2.png');
  if not s.init('images\fade2.png',stopenread) then writeln(gxerror,'images\fade2.png not found');
  check4fail(loadpng(s,image2,32,lddefault));
  showtext('.flare1.png');
  if not s.init('images\flare1.png',stopenread) then writeln(gxerror,'images\flare1.png not found');
  check4fail(loadpng(s,image3,screen.mode.bpp,lddefault));
  fullspeed := false;
  showtext('');
  showtext('This is an early demonstration of the');
  showtext('abilities of GrafX2.');
  showtext('What you will see here are only some');
  showtext('of the image manipulating effects which');
  showtext('are currently built in. More to come');
  showtext('and shown...');
  timer.delay(1000);
  showtext('Starting...');
  runblocking;
  fullspeed := false;
  showtext('----');
  showtext('What you saw was a combination of the');
  showtext('command "blockout" and the command');
  showtext('"brightness_image". The text is an');
  showtext('alphamapped image. You may see: working');
  showtext('with images got very easy in GrafX2 -');
  showtext('no half things anymore! To the next...');
  showtext('Press enter to continue...');
  while not checkbuttons do;
  runadd;
  fullspeed := false;
  showtext('----');
  showtext('This was simply another flag of a');
  showtext('draw-operation. It was used here to');
  showtext('force draw to add the content of the');
  showtext('image to the background of the image.');
  showtext('You are also able to subtract the image');
  showtext('and to work with an alphamap like PNG-');
  showtext('images can contain one.');
  showtext('The next effect - press enter...');
  while not checkbuttons do;
  runxfade;
  fullspeed := false;
  showtext('----');
  showtext('This thing is called crossfading or');
  showtext('alphablending. In GrafX2, the');
  showtext('procedure is called "blend". This');
  showtext('procedure makes of 2 images another,');
  showtext('where you can decide which image');
  showtext('covers more the other.');
  showtext('Enter...');
  while not checkbuttons do;
  runrotate;
  fullspeed := false;
  showtext('----');
  showtext('This is an image rotation. The res-');
  showtext('ponsible routine for this is called');
  showtext('rotate_image. It doesn''t seem to be');
  showtext('very fast here, but in this demo');
  showtext('the rotation is combined with various');
  showtext('other routines. You can reach on a');
  showtext('AMD K6-2 300 up to 20 fps at 640x480x16,');
  showtext('if you only rotate and show the image.');
  showtext('Enter...');
  while not checkbuttons do;
  runscaleup;
  fullspeed := false;
  showtext('----');
  showtext('Much more fancy than the other FX...');
  showtext('Yea, you see two effects combined here.');
  showtext('Scaleup_image and blur_image are doing');
  showtext('their work here. Check the source to');
  showtext('see the details.');
  showtext('Enter...');
  while not checkbuttons do;
  fullspeed := false;
  showtext('----');
  showtext('That''s all folks. More to come soon.');
  showtext('If there occured something which seems');
  showtext('to be a bug, please contact me');
  showtext('immediately. Thanks.');
  showtext('');
  showtext('Stefan  --  stefan.goehler@gmx.de');
  timer.delay(1000);
  showtext('');
  showtext('Enter to exit ;)');
  while not checkbuttons do;
  doexit;
end.