uses grafx2,gx_glob,pnglib,stream32,crt,gx_print;
var
  s       : tfilestream32;
  image   : timage;
  screen  : tgxscreen;

  printer : tprinter;

  ch      : char;

  prtype  : word;
  prport  : word;
  drtype  : word;
  res     : word;

begin
  if not s.init('images\prtest.png',stopenread) then
  begin
    writeln('Could not open source image (images\prtest.png)');
    writeln('Quitting...');
    exit;
  end;
  check4fail(loadpng(s,image,32,lddefault));
  clrscr;
  writeln('*** Printer test menu ***');
  writeln;
  writeln('Please select your printer');
  writeln('[1] Epson ESC/P compatible (needle printers)');
  writeln('[2] Epson ESC/P2 compatible (all newer non HP-printers)');
  writeln('[3] HP PCL compatible (HP and alot laser printers)');
  repeat
    ch := readkey;
    case ch of
      '1' : begin;prtype := mdlepson_esc;res := 180;end;
      '2' : begin;prtype := mdlepson_esc2;res := 360;end;
      '3' : begin;prtype := mdlhp300;res := 300;end;
    end;
  until (ch in ['1'..'3',#27]);
  if ch = #27 then halt;


  writeln;
  writeln('Select color');
  writeln('[1] Black/White printing');
  writeln('[2] Color printing');
  repeat
    ch := readkey;
    case ch of
      '1' : prtype := prtype or mdlclbw;
      '2' : prtype := prtype or mdlclcolor;
    end;
  until (ch in ['1'..'2',#27]);
  if ch = #27 then halt;

  writeln;
  writeln('Select dithering');
  writeln('[1] 4x4 dithering');
  writeln('[2] Error diffusion');
  repeat
    ch := readkey;
    case ch of
      '1' : drtype := pr_dither4x4;
      '2' : drtype := pr_dithererror;
    end;
  until (ch in ['1'..'2',#27]);
  if ch = #27 then halt;
  writeln;
  writeln('Select your printer port');
  writeln('[1] LPT1');
  writeln('[2] LPT2');
  writeln('[3] LPT3');
  repeat
    ch := readkey;
    case ch of
      '1' : prport := lpt1;
      '2' : prport := lpt2;
      '3' : prport := lpt3;
    end;
  until (ch in ['1'..'3',#27]);
  if ch = #27 then halt;

  printer.init(prport,prtype);
  printer.initgraphic(res,res);
  printer.printimage(image,{printer.getprintwidth/image.sizex,
                     printer.getprintheight/image.sizey}1,1,64,drtype);
  printer.donegraphic;
  printer.finishpage;
  printer.done;
  closeimage(image);
end.